#! /bin/bash

# environment variables common to this version/user (=clancy james here! Change this yourself!)

FILEROOT=$1
NEVENTS=$2
PTYP=$3
ENERGY=$4
GENEXE=$5
RADFILE=$6
OUTPUTDIR=$7
MEDFILE=$8

echo "mkdir -vp ${OUTPUTDIR}"
mkdir -vp ${OUTPUTDIR}

cp $MEDFILE optic.dat
cp $RADFILE temp-gen-radii.dat
cp $GENEXE gen.exe

export WLENFILE=optic.dat
export RADFILE=temp-gen-radii.dat
WATMODEL='partic'


set tempseed1=`date +%s`
set SEED1=${tempseed1:5:5}
set SEED2=${tempseed1:4:1}${tempseed1:6:4}
set SEED3=${tempseed1:3:1}${tempseed1:6:4}

if [ "${PTYP}" -eq 5 ]; then
	MANUAL=1
else
	MANUAL=0
fi

export DESCFILE=$FILEROOT.desc
export HBOOKFILE=$FILEROOT.gen


gen.exe <<EOF
# number of events to run
NEVT      ${NEVENTS}
# particle type (5 = muon, 3 = electron)
PTYP      ${PTYP}
# particle energy in gev
LAMB      ${ENERGY}
# first random number seed
SEED      ${SEED1}
# water model id
WMOD     '${WATMODEL}'
# lambda abs from input (if 0 from Geasim)
IABS      1
# second rndm number group
RNDM      ${SEED2} ${SEED3}
# muon-nucleus interactions 
MUNU      0
# hadr. interactions
HADR      4
# photon induced nuclear fission
PFIS      1
# delta ray production
DRAY      1
# continuous energy loss
LOSS      1
# sets track length manually
TLEN	  0.5
# tells the thing to manually set tracklenght
TMAN	${MANUAL}
# emin emax nbins for cross-section tables
ERAN  1.e-5 1.e7 120
# tracking cut for gammas, electrons, neutral hadr, charg hadr, muons, bremmss, ......
CUTS  0.0002  0.0002  0.0002  0.0002  0.0002  0.0002  0.0002  0.0002  0.0002 0.0002
END
EOF

echo "Listing directory contents... \n"
echo "ls -lsh "
ls -lsh

echo "cp ${DESCFILE} ${OUTPUTDIR}/ "
cp $DESCFILE $OUTPUTDIR/

echo "cp *gen ${OUTPUTDIR}/ "
cp *gen $OUTPUTDIR/
