C* Cross product of two, three dimensional vectors returning  Z = X x Y
C*
C* @param X Input. 3 dimensional real vector 
C* @param Y Input. 3 dimensional real vector
C* @param Z Output. 3 dimensional real vector
C* 
C* @test Code verification 
C* @test By <A HREF="mailto:d.bailey2@physics.ox.ac.uk">David 
C* Bailey</A> on 12/12/00 from file verify-gen-cross.f
C* @test Case 1: (0,0,1)x(0,3,0) = (-3,0,0)
C* @test Case 2: (0,0,2)x(0,0,0.5) = (0,0,0)
C* @test Case 3: (0.12,2.22,0.42)x(0.55,-4.21,-1.0001) = (-0.452,0.351,-1.726)
C*/

	SUBROUTINE CROSS(X,Y,Z)

        REAL X,Y,Z

	DIMENSION X(3),Y(3),Z(3)
	Z(1)=X(2)*Y(3)-X(3)*Y(2)
	Z(2)=X(3)*Y(1)-X(1)*Y(3)
	Z(3)=X(1)*Y(2)-X(2)*Y(1)

	RETURN
	END
