C* Original author: Martin Moorhead<BR>
C* Original date: 27 July 1997<BR>
C*
C* Find the scattering length for a given wavelength
C*
C* @param wlength Wavelength in nm
C* @param lscat Scattering length in m
C*
C* @warning UNVERIFIED
C*/

      SUBROUTINE find_lscat( wlength, lscat)

      include 'gen.inc'

      REAL*8    lscat, wlength, slope
C
C--- find the wavelength bin for this wavelength 
C--- already done now
c      call find_wlen_bin( wlength, i_bin)

      if ( P_wlbin .eq. 0) then
C
C--- extrapolate below first bin 
C
         slope = (in_l_scat(2)-in_l_scat(1)) / (in_wlen(2) - in_wlen(1))
         lscat = in_l_scat(1) + (wlength - in_wlen(1)) * slope

      elseif ( P_wlbin .eq. in_nwavelens) then
C
C--- extrapolate above last bin 
C
         slope = (in_l_scat(in_nwavelens)-in_l_scat(in_nwavelens-1)) / 
     1           (in_wlen(in_nwavelens) - in_wlen(in_nwavelens-1))
         lscat = in_l_scat(in_nwavelens) + (wlength - 
     1           in_wlen(in_nwavelens)) * slope

      else
C
C--- interpolate 
C
         slope = (in_l_scat(P_wlbin+1)-in_l_scat(P_wlbin)) / 
     1           (in_wlen(P_wlbin+1) - in_wlen(P_wlbin))
         lscat = in_l_scat(P_wlbin)+(wlength - in_wlen(P_wlbin))*slope
      endif
C
C--- check for unphysical extrapolations
C
      if ( lscat .le. 0.0 ) lscat = 0.1

      return
      end
