C* Original author: Martin Moorhead<BR>
C* Original date: 27 July 1997<BR>
C*
C* Find the wavelength bin (in the in_wlen array) for a given wavelength
C* If the wavelength is less than in_wlen(1) then i_bin=0 is returned.
C*
C* @param wlength Wavelength in nm
C* @param i_bin The bin index for which:
C*              in_wlen(i_bin) < wlength < in_wlen(i_bin+1)
C*
C* @warning UNVERIFIED
C*/

      SUBROUTINE find_wlen_bin(wlength)

      include 'gen.inc'

      integer*4 i_bin 
      real*8    wlength
C
C--- calculate first guess for i_bin
C
      i_bin = 1 + int((wlength-in_wlen(1)) * float(in_nwavelens-1)) / 
     1        (in_wlen(in_nwavelens)-in_wlen(1)) 
  	

      if ( i_bin .lt. 1 ) then
C
C--- reset i_bin to lowest bin
C
         i_bin = 1
      elseif( i_bin .ge. in_nwavelens ) then
C
C--- reset i_bin to highest bin-1
C
         i_bin = in_nwavelens - 1
      endif
C
C--- main loop  
C
      do i = 1, in_nwavelens
         if ( (i_bin .eq. 0) .or. (i_bin .eq. in_nwavelens) ) then
            go to 999
         elseif ( in_wlen(i_bin) .gt. wlength ) then
            i_bin = i_bin - 1
         elseif ( in_wlen(i_bin+1) .lt. wlength ) then
            i_bin = i_bin + 1
         else
            go to 999
         endif  
      enddo
      
999   CONTINUE
      P_wlbin=i_bin
            
      end
