C* Generate a pseudorandom, gaussian distributed number with mean 0 and
C* standard deviation 1. The random number is generated with ran1.
C*
C* @param idum An integer argument passed to ran1
C*
C* @return A gaussian distributed pseudorandom number with mean 0 and standard
C*         deviation 1
C*
C* @see gen-km3-ran1.f
C*
C* @warning UNVERIFIED
C*/

      REAL*4 FUNCTION RAN_GAUSS(IDUM)

      IMPLICIT NONE

      INTEGER*4 IDUM, ISET
      REAL*4    GSET, V1, V2, R, FAC, ran1
      SAVE ISET, GSET

      IF (ISET.EQ.0) THEN
1       V1=2.*RAN1(IDUM)-1.
        V2=2.*RAN1(IDUM)-1.
        R=V1*V1+V2*V2
        IF(R.GE.1.)GO TO 1
        FAC=SQRT(-2.*LOG(R)/R)
        GSET=V1*FAC
        RAN_GAUSS=V2*FAC
        ISET=1
      ELSE
        RAN_GAUSS=GSET
        ISET=0
      ENDIF
      RETURN
      END
