C* Generates isotropically pointing vector with length RAD
C* Now uses ran1 routine as an interface to RANLUX
C*
C* @param X Output. The isotropic vector
C* @param RAD Input. The length of the vector to be sampled
C*
C* @test Code verification:
C* @test By <A HREF="mailto:d.bailey2@physics.ox.ac.uk">David 
C* Bailey</A> on 14/12/00 from file verify-gen-ranvector.f
C* @test Generate 1000000 vectors and plot the zenith and azimuthal angle
C*       distributions
C* @test <IMG SRC="verify-gen-ranvector.gif">
C*/

	SUBROUTINE RANVECTOR(X,RAD)

	include 'gen.inc'

	REAL X(3)
	real*4 ran1

1	CONTINUE
	DO K=1,3
		X(K)=2.*(ran1(in_seed)-.5)
	END DO
	RMOD=X(1)**2+X(2)**2+X(3)**2
	IF(RMOD.GT.1.) GOTO 1
	CALL NORMALIZE(X)
	DO K=1,3
		X(K)=X(K)*RAD
	END DO
	RETURN
	END
