C* Given a random number between 0 and 1, return cos(theta) according
C* the a Rayleigh scattering angular distribution
C*
C* @param r Input. A random number between 0 and 1
C* @param cosp Output. The scattering angle sampled according to Rayleigh
C*        scattering
C*
C*/

        subroutine rayleigh(r,cosp)

         real*8 r,cosp
         real*8 b,p,q,d,u1,v1,u,v
         b = 0.835d0
         p = 1./b
         q = (b+3.)*(r-0.5)/b
         d = q*q +p*p*p
         u1 = -q+sqrt(d)
         u = (abs(u1))**(1./3.)
         if (u1.lt.0.) u = -1.d0*u
         v1 = -q-sqrt(d)
         v = (abs(v1))**(1./3.)
         if (v1.lt.0.) v = -1.d0*v
	 cosp = MAX(-1.d0 , MIN( 1.d0 , u+v )) 
         return
         end
