C*/
	subroutine ugeom  

! GEANT-required routine to define user geometry
	include 'gen-geant.inc'
	include 'gen.inc'
	include 'gen-hit-ntuple.inc'

! Half-lengths of sides of master volume; currently volume is 40 m on a side
! for complete shower containment
	real amda_dim(3)	
	data amda_dim/2000.,2000.,2000./
	real water_dim(3)
	data water_dim/2000.,2000.,2000./

! Variables used to define water properties for GEANT
	real a_water(2),z_water(2),w_water(2)
	data a_water,z_water,w_water/16.,1.,8.,1.,1.,2./

        integer nseawater
	parameter (NSW=5)
	real a_seawater(NSW),z_seawater(NSW),w_seawater(NSW)
c   Seawater salt content taken from  ANTARES-PHYS-2006-005-2
c   note that the oxygen content has been increased by 0.0001 so the 
c   weights sum to 100%
        data a_seawater,z_seawater,w_seawater/
     &   15.9994,1.00794, 22.9898, 35.4527, 24.3050,
     &   8,1,11,17,12,
     &   0.8542, 0.1074, 0.0132, 0.0237, 0.0015/

! Define the standard materials plus a definition of water (or ice,
! if dens_medium=0.9)
	call gmate
	if (I_MEDIUM .lt. 3) then
	   write(*,*) 'using pure water'
	   call gsmixt(17,'Water$',a_water,z_water,dens_medium,-2,w_water)
	else
	   write(*,*) 'using seawater'
	   call gsmixt(17,'Water$',a_seawater,z_seawater,dens_medium,
     & NSW,w_seawater)
	endif
! Define the tracking media
	ifield=0	! No B field
	fieldm=0.0
	tmaxfd=0.0
	dmaxms=0.1	! Max displ from multiple scattering (cm)
	deemax=1.0	! Max fractional E loss in one step
	epsil=0.1	! Tracking precision (cm)
	stmin=0.1	! Minimum step due to E loss or MCS (cm)

	nmat=17		! Water
	isvol=1		! Sensitive detector
	call gstmed(3,'Water    $',
	1	nmat,isvol,ifield,fieldm,tmaxfd,dmaxms,deemax,epsil,stmin,0,0)

	nmat=15		! Air
	isvol=0
	call gstmed(1,'Air      $',
	1	nmat,isvol,ifield,fieldm,tmaxfd,dmaxms,deemax,epsil,stmin,0,0)

! Define geometry

! Master coordinate system
	call gsvolu('AMDA','BOX ',1,amda_dim,3,ivol)

! Block of water, 40 m each side
	call gsvolu('WATE','BOX ',3,water_dim,3,ivol)
	call gspos('WATE',1,'AMDA',0.,0.,0.,0,'ONLY')

! Close geometry banks (required call)
	call ggclos

	return
	end
