      real function effang(ct,ev)
* ---------------------------------
c     calculate weight for photon which hits PM under
c     angle th (degree) w.r.t. axis with cos(th) = ct
c     Fit from M. Spurio to NIM figure
c
c      parameter (a0 = 0.2549)
c      parameter (a1 = 0.6093)
c      parameter (a2 = 0.2556)
c      parameter (a3 =-0.1231)
c      parameter (a4 = 0.)
c      parameter (a5 = 0.)
c      
c     Fit from Genova- GEANT4 - December 2008 (Heide Costantini)
c     GE6 param, cutoff at costheta=-0.65 [known as 'dic08']
c
c      parameter (a0 = 0.3265)
c      parameter (a1 = 0.6144)
c      parameter (a2 =-0.0343)
c      parameter (a3 =-0.0641)
c      parameter (a4 = 0.2988)
c      parameter (a5 =-0.1422)
      
      include 'hit.inc'
      
      REAL*4 wang, real_bin, k1, k2, ct, coef,ev, kev1, kev2
      INTEGER b1,b2,i, iev1, iev2
      
      if(PMT_effang_meth .eq. 1) then
c calculate directly
      	 if (ct.lt.PMT_mincos) then
      	    wang = PMT_min_effang
      	 elseif (ct.ge.1.) then
            wang = 1.
      	 else
	    coef=1.
	    wang = PMT_effang_a(1)
	    do i=2, PMT_na
	       coef = coef*ct
      	       wang = wang + coef*PMT_effang_a(i)
	    enddo
         endif
      else
c use a histogram
      	 if (ct.lt.PMT_mincos) then
      	    wang = PMT_min_effang
      	 elseif (ct.ge. 1.) then
      	    wang=1.
      	 elseif (PMT_nev .eq. 1) then
	    real_bin = (ct-PMT_mincos)/PMT_dcos
	    b1 = int(real_bin)+1
	    IF (b1 .le. 0) b1=1
	    if (b1 .ge. PMT_NCOS) b1 = PMT_NCOS-1
	    b2 = b1+1
	    k1 = b1-real_bin
	    wang = PMT_effang(b1,1)*k1 + PMT_effang(b2,1)*(1.-k1)
	    wang = exp(wang)
	 else
c the tables are the central ev values
	    if (ev .lt. PMT_evmin) then
	       iev1=1
	    elseif (ev .ge. PMT_evmax) then
	       iev1=PMT_nev-1
	    else
	       iev1=1+int((ev-PMT_evmin)/PMT_dev)
	    endif
	    iev2=iev1+1
	    kev1=(PMT_ev(iev2)-ev)/PMT_dev
	    kev2=1.-kev1
	    
	    real_bin = (ct-PMT_mincos)/PMT_dcos
	    b1 = int(real_bin)+1
	    IF (b1 .le. 0) b1=1
	    if (b1 .ge. PMT_NCOS) b1 = PMT_NCOS-1
	    b2 = b1+1
	    k1 = b1-real_bin
	    k2 = 1.-k1
	    wang = kev1*(PMT_effang(b1,iev1)*k1 +
     &               	PMT_effang(b2,iev1)*(1.-k1) )
     &             + kev2*(PMT_effang(b1,iev2)*k1 +
     &               	PMT_effang(b2,iev2)*(1.-k1) )
	    wang = exp(wang)
	 endif
	  
      endif
      
      effang = wang
      return
      end
