C*/
      SUBROUTINE PRINT_PMT_EFF
*************************************************************************
*     Name           :  PRINT_PMT_EFF                                   *
*     Called by      :  MAIN PROGRAM                                    *
*     Author         :  Sergio Navas                                    *
*     Date           :  27-Nov-1998                                     *
*     Task           :  Printout (unit 35) the PMT eff. area computed   *
*                       in function 'pmt_eff_area' (pmt_eff.f) for      *
* a couple points (energy,angle) to check that the values are correct   *
*************************************************************************
*
      INCLUDE 'hit.inc'
      INTEGER I, J, NLAMBDA
      PARAMETER  (NLAMBDA = 10)
      REAL LAMBDA(NLAMBDA), ENERGY, DOT, eap, eff_area_pmt
      DATA LAMBDA/
     &            310.0, 350.0, 355.0, 400.0, 450.0, 473.0, 
     &            500.0, 532.0, 550.0, 600.0  
     &           /
*
      WRITE(*,*) '  PMT Eff_Area as a function of (Energy,theta) '
      WRITE(*,380)

      ENERGY = 0.
      DOT    = 0.

      DO J = 1, NLAMBDA
        ENERGY = con_wlen_to_energy/LAMBDA(J)
        DO I = 1, 111, 5
          DOT = COS(float(I-1)/57.2957795131)
      	  eap=eff_area_pmt(ENERGY,DOT)
          WRITE(*,390) LAMBDA(J), ENERGY, DOT, 
     &         eap,(I-1)

       ENDDO
      ENDDO
*
 380  FORMAT('  LAMBDA   ENERGY   cos(theta)  Eff_Area  theta',/,
     &       '  ------   -------  ----------  --------  ------')
 390  FORMAT(F8.2,2X,F8.5,F10.6,1X,F11.7,1X,I5)
*
**
*
 999  CONTINUE
      END
