C*/
      SUBROUTINE sort( N, ARR1, ARR2)

*     Created:  12-June-96
*     Contact:  M. Moorhead, LBNL.
*     Verified:

*     Purpose:-
*     =============
c     Use numerical recipes method SHELL to sort array into ascending order
c     of ARR1 values whilst preserving the relation between the ARR1 and ARR2
c     arrays

*     In/Out Variables:-
*     ==========
c     in 	N 	number of elements in array
c     in/out    ARR1     array of first elements (used for ordering)
c     in/out    ARR2     array of second elements (correlated to ARR1)

*     Common Block Access:-
*     ===================

*     Assumptions:-
*     ===========
 
*     Revision History:-
*     ================
c     V1	M. Moorhead	Created routine
      
      include 'hit.inc'

      INTEGER*4 n, m, nn, lognb2, k, i, j, l
      REAL*4    arr1(max_hits), arr2(max_hits), 
     1          t1, t2, aln2i, tiny 

      PARAMETER (aln2i = 1.0d0/0.69314718d0, tiny = 1.0d-5 )

      lognb2 = int( alog( float( n )) * aln2i + tiny )
      m = n

      do nn = 1, lognb2    ! loop over the partial sorts

         m = m / 2
         k = n - m

         do j = 1, k       ! outer loop of straight insertion

            i = j
3           continue

            l = i + m

            if ( arr1(l) .lt. arr1(i) ) then

               t1 = arr1(i)
               t2 = arr2(i)

               arr1(i) = arr1(l)
               arr2(i) = arr2(l)

               arr1(l) = t1
               arr2(l) = t2

               i = i - m

               if ( i .ge. 1 ) goto 3

            endif

         enddo

      enddo

      end
