C*/
      SUBROUTINE write_desc_file

*     Created:  12-July-96
*     Contact:  M. Moorhead, LBNL.
*     Verified:

*     Purpose:-
*     =============
*     output the .desc file which accompanies the HIT distributions .rz file 
*
*     Common Block Access:-
*     ===================
c     /hit/  	in 		holds structures for HIT program

*     Assumptions:-
*     ===========

*     Revision History:-
*     ================
c     V1	M. Moorhead	Created routine

      include 'hit.inc'
      
      integer i
c find the name of the output .desc files

c open the output .desc file for the HIT distributions

      open (unit = lun_out_desc, file = H_file_out_desc,
     & status='unknown')
      write(6,*) ' opening for output .desc file: ',H_file_out_desc
      
c output global info 
c        -----------
c
      write (lun_out_desc, 456) H_file_in_desc
 456  format(a120, ' input photon field RZ filename')
      write (lun_out_desc, *) h_part_id, '  Geant ID of primary part.'
      write (lun_out_desc, *) h_part_energy, '  energy of prim. part.'
      write (lun_out_desc, *) h_i_medium,
     & ' ID medium(1/2/3=ice/water/sea)'
      write (lun_out_desc, *) h_n_ref, '  ref. index of medium'
      write (lun_out_desc, *) h_dens_medium, '  density of medium'
      write (lun_out_desc, *) h_seg_length, '  segment/shower length'
      write (lun_out_desc, *) h_min_ion_eloss, '  min_ion_eloss '
      write (lun_out_desc, *) h_e_thresh, '  max muon eloss '

c output radii info
c        ----------
c
      write (lun_out_desc, *) r_nbins, '  number of radii bins'
      write (lun_out_desc, *) r_rad(1), '  minimum radius '
      write (lun_out_desc, *) r_rad(r_nbins), '  maximum radius '
      write (lun_out_desc, *) r_power, '  power for linear interp.'

      write(*,*) '===> hit.f r_nbins=',r_nbins,r_rad(1),r_rad(r_nbins)

c write out band info for direct hit photons (only for non-muons)
c           --------------------------------
c

c  ##### NEVER DO THIS (below); NO NON-MUON DIRECT HITS! ####
c introduce some changes to print-out the specific photon (LASER-flash) info
c
c      if ( h_part_id .ne. id_muon ) then 
c the primary particle is NOT a muon and we need to output relevant info...
c
c low bands :
c          write (lun_out_desc, *) b_n_low(0), '  # low bins '
c          write (lun_out_desc, *) b_power_low(0), '  power '
c          write (lun_out_desc, *) b_step_low(0), '  step '
c          write (lun_out_desc, *) b_cos_ave(0,1,1), '  min '
c          write (lun_out_desc, *) b_cos_ave(0,1,b_n_low(0)), '  max'

c the primary particle is NOT a photon...
c
c high bands :
c          if ( h_part_id .ne. id_photon) then 
c            write (lun_out_desc, *) b_n_high(0), '  # high bins '
c            write (lun_out_desc, *) b_power_high(0), '  power '
c            write (lun_out_desc, *) b_step_high(0), '  step '
c            write (lun_out_desc, *) b_cos_ave(0,1,b_n_low(0)+1),'  min'
c            write (lun_out_desc, *) b_cos_ave(0,1,b_nbins(0)), '  max'
c          endif
c      endif

c write out OM angle info for direct photons
c           --------------------------------
      if (h_part_id .eq. id_muon) then
      	 write (lun_out_desc, *) h_nbins_om_theta(0), 
     1                        '  # of direct OM theta bins'
      endif
c write out band info for scattered photons
c           -------------------------------
c low bands :
      write (lun_out_desc, *) b_n_low(1), '  # low bins '
      write (lun_out_desc, *) b_power_low(1), '  power '
      write (lun_out_desc, *) b_step_low(1), '  step '
      write (lun_out_desc, *) b_cos_ave(1,1,1), '  min'
      write (lun_out_desc, *) b_cos_ave(1,1,b_n_low(1)), '  max'

c the primary particle is NOT a photon...
c
c high bands :
      if ( h_part_id .ne. id_photon) then 
      	 write (lun_out_desc, *) b_n_high(1), '  # high bins '
      	 write (lun_out_desc, *) b_power_high(1), '  power '
      	 write (lun_out_desc, *) b_step_high(1), '  step '
      	 write (lun_out_desc, *) b_cos_ave(1,1,b_n_low(1)+1),'  min'
      	 write (lun_out_desc, *) b_cos_ave(1,1,b_nbins(1)), '  max'
      endif

c write om theta and phi bins
c      if (h_part_id .eq. id_muon) then
c      	 write(lun_out_desc, *) h_nbins_om_theta(0), ' # dir theta bins'
c	 write(lun_out_desc, *) h_nbins_om_phi(0), ' # dir phi bins'
c      endif
      write(lun_out_desc, *) h_nbins_om_theta(1),
     & ' # scat theta_om bins'
      write(lun_out_desc, *) h_nbins_om_phi(1),
     & ' # scat phi_om bins'

c write number of time bins for direct and scattered photons
c                 ------------------------------------------
      if (h_part_id .eq. id_muon) then
      	 write (lun_out_desc, *) h_nbins_time(0),
     1                        '  # of time bins:direct'
      endif
      write (lun_out_desc, *) h_nbins_time(1),
     1                        '  # of time bins:scttrd'
      write (lun_out_desc, *) B_tmeth, ' # time binning method'
c writing time distribution for direct hits, if applicable     
      if (h_part_id .eq. id_muon) then
      	 do i=0,h_nbins_time(0)
            write (lun_out_desc, *) x_cheby(0,i)*h_nbins_time(0)
      	 enddo
      endif
c writing time distribution for scattered hits
      do i=0,h_nbins_time(1)
         write (lun_out_desc, *) x_cheby(1,i)*h_nbins_time(1)
      enddo
      
      write (lun_out_desc, *) watmod,' = Water model name'
      write (lun_out_desc, *) labs,' = absorption length'
      write (lun_out_desc, *) lscat,' = scattering length'
      write (lun_out_desc, *) luz,' = at this photon wavelengh'
      write (lun_out_desc, *) alpha,' = alpha'
      write (lun_out_desc, *) cosme1,' = cosme 1'
      write (lun_out_desc, *) cosme2,' = cosme 2'
      write (lun_out_desc, *) eta,' = eta'
      write (lun_out_desc, *) '1 1 1 1 79 ',t_dis_scat(1,1,1,1,79),
     & ' = check digit'
      
      
      end
