C*/
      SUBROUTINE write_rz_file

*     Created:  12-July-96
*     Contact:  M. Moorhead, LBNL.
*     Drastic modification: no longer uses ntuples in order to save space

*     Purpose:-
*     =============
*     output the HIT distributions into a .rz file with ntuple formats
*
*     Common Block Access:-
*     ===================
c     /hit/  	in 		holds structures for HIT program

*     Assumptions:-
*     ===========

*     Revision History:-
*     ================
c     V1	M. Moorhead	Created routine

      include 'hit.inc'

      integer*4     i, j, k, l, m, n, icycle, ierror
      character*120 file_out_rz
      integer*4 rec_length
      integer*4 count
c close the input .rz file and clear the histograms from local memory

      call hrend('LUN1')
      close(lun_in_rz)
      call hdelet(0)

c find the name of the output .rz file

      CALL GETENV('HITHBOOK',file_out_rz)

      write(*,*) ' Output .RZ file (for the HIT distribution ntuples)?'
C      read(*,'(a120)') file_out_rz
      write(6,*) file_out_rz

      write(*,*) 'Opening unit ', LUN_OUT_RZ
      write(*,*) 'Writing to file ', file_out_rz
      
      rec_length=4*(h_nbins_time(1)+2)
      
c open the output .rz file for the HIT distributions
      OPEN(UNIT=LUN_OUT_RZ, FILE=file_out_rz, ACCESS='DIRECT',
     &  STATUS='UNKNOWN', FORM='UNFORMATTED', RECL=rec_length,
     &  IOSTAT=ierror)
     
      write(*,*) ' Did HROPEN for output rz file -> ',ierror


c fill the  ntuples starting with scatterd only - this is for electrons!
      count=1
      if (h_part_id .eq. 3) then
      	 write(*,*) 'Electron - no direct distribution being written'
	 GOTO 666
      ENDIF
      write(*,*) 'Not an electron - writing the direct distributions'
      do i = 1, r_nbins  ! loop over shells
      	 do j = 1, b_nbins(0)  ! loop over bands (theta_track)
      	    do k = 1, h_nbins_om_theta(0)
      	       do l = 1, h_nbins_om_phi(0)  ! loop over phi_OM orientations
      	          write(LUN_OUT_RZ,rec=count) n_det_dir(i,j,k,l),
     & (t_dis_dir(i,j,k,l,m),m=0,h_nbins_time(0))
      	          count = count+1
               enddo
            enddo
         enddo
      enddo
      write(*,*) count-1, ' lines of o/p written for direct dists'
 666  do i = 1, r_nbins  ! loop over shells
      	 do j = 1, b_nbins(1)  ! loop over bands (theta_track)
      	    do k = 1, h_nbins_om_theta(1)
      	       do l = 1, h_nbins_om_phi(1)  ! loop over phi_OM orientations
      	          write(LUN_OUT_RZ,rec=count) n_det_scat(i,j,k,l),
     & (t_dis_scat(i,j,k,l,m),m=0,h_nbins_time(1))
      	          count = count+1
               enddo
            enddo
         enddo
      enddo
      write(*,*) count-1, ' lines of o/p total (direct + scattered)'
      write(*,*) 'the rec length should be ', rec_length
      CLOSE(LUN_OUT_RZ)

*
* Print x values for the time cumulative distribution
* according to Chebysev
*
      write(*,*)
      write(*,*)' ==> X values Chebysev (time interpolation) <== nbins='
     &,max_t_scat
      write(*,*)
      do k=0,max_t_scat
        write(*,*) 'bin=',k,' value=',x_cheby(0,k),x_cheby(1,k)
      enddo


      end
