C*/
      subroutine chebysev      
*************************************************************************
*     Name           :  chebysev                                        *
*     Called by      :                                                  *
*     Author         :  Juan Zuniga                                     *
*     Date           :  7-Feb-2000                                      *
*     Task           :  Compute x values for time interpolation         *
*                    :  according to Chebysev formula.                  *
*                                                                       *
*************************************************************************
      include 'km3.inc'
      include 'km3-interpol.inc'
      real*4 x_a,x_b,xm,xd,pbeta
      integer*4 i
c------------------------------------------------------------------------
c  Compute x values for interpolation
c------------------------------------------------------------------------

      write(61,*) ' CHEBYSEV: Compute x values for time interpolation'
      if (H_CHEB .eq. 1) then
c      	 chebychev binning has been used
      	 x_a = 0.0
      	 x_b = float(max_time)
      
      	 xm = (x_a+x_b)/2.
      	 xd = (x_b-x_a)/2.
      	 x_cheb(0) = x_a
      	 x_cheb(max_time) = float(max_time)
      
      	 do i=1, max_time-1
            pbeta = -cos(c_pi*(2.*float(i)+1.)
     &         /(2.*float(max_time)+2.))
            x_cheb(i) = xm+xd*pbeta
            write(61,*) ' x_cheb(',i,')=',x_cheb(i)
      	 enddo
      else
c     	 standard linear binning has been used
      	 do i=1,max_time-1
	    x_cheb(i)=i
	 enddo
	 x_cheb(0)=0.
	 x_cheb(max_time)=float(max_time)
      endif
	 
	 
      return
      end
