      subroutine step_muon
     *(x00,y00,z00,thetax00,thetay00,thetaz00,Emuin0,tmu0,step0,
     *x000,y000,z000,thetax000,thetay000,thetaz000,Emuin00,tmu00,
     *step00)
      implicit real*8 (a-h,o-z)
      real*4 x00,y00,z00,thetax00,thetay00,thetaz00,emuin0,tmu0,step0
      real*4 x000,y000,z000,thetax000,thetay000,thetaz000,emuin00,
     *tmu00,step00
      real*8 theta01,phi01,mmu
      REAL*8 n_a,n_z,n_rho,n_lambda
      COMMON/rock2/n_a,n_z,n_rho,n_lambda
	parameter (pi=3.141592654d0)
        parameter (mmu=0.105658)
      x0=x00*100.
      y0=y00*100.
      z0=z00*100.
      thetax0=thetax00
      thetay0=thetay00
      thetaz0=thetaz00
      emuin=emuin0
      step=step0

                                !input and output parameters:
        emu_f=0.                !final muon energy

        depth=step0*100.*n_rho   !depth along z-axis in g/cm^2, input
        path_max=1000000.*100.  !maximal path of muon, input
        emu=emuin               !initial muon energy, input

        theta=0.                !angle with respect to z-axis, input and output
        phi=0.                  !angle with respect to x-axis, input and output
        dr=0.                   !muon path in the rock, output
        x=0.                    !deviation along the axes x,y, perpendicular
        y=0.                    !to z-axis, x,y-axes should be defined,
                                !input and output
        z=0.                    !z-coordinate
        t=0.                    !Initial muon path in rock, input
                                !emu_f - final energy of muon

        theta0=theta
        phi0=phi
        emu_0=emu

        CALL music(emu,depth,emu_f,x,y,z,t,theta,phi,dr,path_max)

        if(Emu_f.lt.0.106) then
           gamma = 1
           beta = 0
           vmu = 0
           tmu = 0
        else
           gamma=(Emu_0+Emu_f)/2./mmu
           beta=dsqrt(gamma*gamma-1.)/gamma
           vmu=beta*29.9792458
           tmu=dr/vmu/n_rho
        end if

        tmu00=tmu0+tmu
        step00=z/100.

        thetac=dacos(thetaz0)
      IF(thetax0.NE.0.) THEN
         phic=datan(thetay0/thetax0)
        IF(thetax0.LT.0.) phic=pi+phic
      END IF
      IF(thetax0.EQ.0.) THEN
        phic=pi/2.
        IF(thetay0.LT.0.) phic=pi*3./2.
      END IF
      IF(phic.GT.pi*2.) phic=-pi*2.+phic
      IF(phic.LT.0.) phic=phic+pi*2.
        call coord_transform(x1,y1,z1,x,y,z,thetac,phic)
        x0=x1/n_rho+x0
        y0=y1/n_rho+y0
        z0=z1/n_rho+z0
        theta0=thetac
        phi0=phic
        call angle_transform(theta0,phi0,theta,phi)
        thetaz0=dcos(theta0)
        thetax0=dsin(theta0)*dcos(phi0)
        thetay0=dsin(theta0)*dsin(phi0)

        thetax000=thetax0
        thetay000=thetay0
        thetaz000=thetaz0
        emuin00=emu_f                  ! if emu_f is less than 0.105658 the muon
                                       ! has stopped
        if(emuin00.le.0.106) emuin00=mmu
        x000=x0/100.
        y000=y0/100.
        z000=z0/100.

        return
        end
