C*/
	SUBROUTINE OPEN_ANTARES_EVENT_FILE(i_err,CHVERS)
	INCLUDE 'km3.inc'
	INCLUDE 'km3-detgeo.inc'
c	INCLUDE 'km3-phomul.inc'
c
c--- open the input event file with ANTARES format events
c
        CHARACTER*255 CHGEOFIL	! full geametry file name
        CHARACTER*255 CHX       ! geometry name with "1 1" at the end 
        CHARACTER*255 CHLINE	! input string from event buffer
        CHARACTER*255 EVTAGN
        CHARACTER*12   CHVERS
        CHARACTER*10  OPSYS     ! Operative system (Linux, HP-UX, OSF1, ...)
        INTEGER*4 i_err, j
        INTEGER IDAT, ITIM	! current date and time
        INTEGER NCH, LENOCC, NRUN, NEVENT, IEV, NDATEV
        LOGICAL NEW_R,NEW_E
*
        CALL GETENV('OPSYS',OPSYS)    ! Linux , HP-UX , OSF1 ...

	OPEN(UNIT=IO_UNEVENT,FILE=io_event_file,STATUS='OLD',
     &   IOSTAT=i_err)

	write(*,*) 'Open file ',IO_EVENT_FILE,' Unit=',IO_UNEVENT
	
	IF(i_err.NE.0) THEN
	  WRITE(*,*) ' Error opening ANTARES event file',i_err
	  RETURN
	END IF
c
c--- read/write run header
c
	CALL EVREAD(IO_UNEVENT,I_ERR)
	IF (I_ERR.NE.0) THEN
	  WRITE(*,*) ' OPEN_ANTARES_EVENT ERROR reading the header',i_err
	  RETURN
	ENDIF
	CALL EVINFO(NEW_R,NEW_E,NRUN,NEVENT,IEV)
	IF (NEW_R) THEN
c
c--- give version stamp, date time
c
	  CALL DATIME(IDAT,ITIM)
	  WRITE(CHLINE,'('' KM3 '',A12,I7.6,I5.4)') CHVERS,IDAT,ITIM
	  CALL EVTAGA('simul',CHLINE,I_ERR)
	  WRITE(CHLINE,'(A10)') OPSYS
	  CALL EVTAGA('node',CHLINE,I_ERR)
c
c--- explore 'detector' tag
c
c--- 02/11/2009 : write new detector tag always into output file
c	  IF (NDATEV('detector').GE.1) THEN
c	    CHGEOFIL = EVTAGN('detector')
c	  ELSEIF (NDATEV('detector').EQ.0) THEN
	    CHGEOFIL = io_geom_file
            WRITE(CHX,'(A120,I2,I2)') io_geom_file,1,1
	    CALL EVTAGA('detector',CHX,I_ERR)
c	  ENDIF
	  CALL CLEFT(CHGEOFIL,1,LEN(CHGEOFIL)) ! eliminate leading blanks
c
c--- change name into "mmdetector"
c
	  NCH = LENOCC(CHGEOFIL)
	  IF (NCH.GT.8.AND.NCH.LE.253) THEN
	    IF (CHGEOFIL(NCH-8:NCH)  .EQ. '.detector')
	1	 CHGEOFIL(NCH-8:NCH+2) =   '.mmdetector'
	  ENDIF
	  io_geom_file = CHGEOFIL(1:120)
c
c--- explore 'can' tag
c
c	  IF (NDATEV('can').GE.1) THEN
c	    CHLINE = EVTAGN('can')
c	    READ(CHLINE,*) ZMINS,ZMAXS,RADS
cc            ELSEIF(NDATEV('can').EQ.0) THEN
cc            WRITE(CHLINE,'(3F12.3)') ZMINS,ZMAXS,RADS
cc            CALL EVTAGA('can',CHLINE,I_ERR)
c	  ENDIF
c
c--- explore 'seed' tag
c
	  write(*,*) ' NDATEV==',NDATEV('seed')
	  WRITE(CHLINE,'('' KM3 '',2I9)') ISEED(1),ISEED(2)
*	1      ,ISEED(3),ISEED(4)
          CALL EVTAGA('seed',CHLINE,I_ERR)
	  
c	  IF (NDATEV('seed').GE.1) THEN
c	    CHLINE = EVTAGN('seed')
cc	    READ(CHLINE,*) ILUX,IISEED,K1,K2         !changed the 12th March 99
c	    READ(CHLINE,*) DUMMY,ILUX,IISEED,K1,K2
cc             ELSEIF(NDATEV('seed').EQ.0) THEN
cc             WRITE(CHLINE,'(I3,3I12)') ILUX,IISEED,K1,K2
cc             CALL EVTAGA('seed',CHLINE,I_ERR)
c	  ENDIF
c
c--- write additional data cards
c
*
* Write the reference to the "water model" used -> name of the .desc file 
*
	  WRITE(CHLINE,388) watmod,labs,lscat,luz,alpha,cosme1,cosme2,eta
 388	  format(A6,F7.2,F7.2,5(1X,F8.3))
	  CALL EVTAGA('water_model',CHLINE,I_ERR)
	  IF (I_ERR.NE.0) THEN
	    WRITE(6,*) '** Error from EVTAGA water model',I_ERR
	  ENDIF
c 388	  format(A6,' abs.len.=',F7.2,' m scat.len.=',F7.2,' m alpha='
c     &    ,F7.3,' cosme1=',F7.3,' cosme2=',F7.3,' eta=',F7.3)

	  WRITE(CHLINE,'(A80)') io_muon_desc_file
	  CALL EVTAGA('muon_desc_file',CHLINE,I_ERR)
	  IF (I_ERR.NE.0) THEN
	    WRITE(6,*) '** Error from EVTAGA water_model_file',I_ERR
	  ENDIF
*
* Write the following info corresponding to the first PM:
*    Type id, effective area (cm^2), tts (sigma/nsec)
	  WRITE(CHLINE,'(I4,2(1X,F10.4))') IDPMTYP(1),AEFTYP(IDPMTYP(1)),
     &                                 TTSTYP(IDPMTYP(1))
	  CALL EVTAGA('PM1_type_area_TTS',CHLINE,I_ERR)
	  IF (I_ERR.NE.0) THEN
	    WRITE(6,*) '** Error from EVTAGA PM1_type_area_TTS',I_ERR
	  ENDIF
C
C--- write coord_origin if not there in input event stream
C
	  IF (NDATEV('coord_origin').EQ.0) THEN
	    WRITE(CHLINE,'(3F10.3)') (VCOG(J),J=1,3)
	    CALL EVTAGA('coord_origin',CHLINE,I_ERR)
	    IF (I_ERR.NE.0) THEN
	      WRITE(6,*) '** Error from EVTAGA coord_origin',I_ERR
	    ENDIF
	  ENDIF
C
C--- K40 simulation
C
	  WRITE(CHLINE,'(I8,I6)') IK40(1),IK40(2)
	  CALL EVTAGA('k40',CHLINE,I_ERR)
c
c--- TMERG=time window (ns) in which hits are added and treated as one hit
c
	  WRITE(CHLINE,'(F6.1,I3)') TMERG, JGAIN
	  CALL EVTAGA('merg',CHLINE,I_ERR)
*
C--- Group or phase velocity
    
          WRITE(CHLINE,'(I3)') TNGRP
          CALL EVTAGA('v_light',CHLINE,I_ERR)
         
	ENDIF
*
	END
