C*/
      SUBROUTINE ratint(xa,ya,n,x,y,dy)
c------------------------------------------------------------------
c  Rational Interpolation 
c  From Numerical Recipes
c
c The "tiny" parameter is needed to prevent a rare zero-over-zero
c condition
c------------------------------------------------------------------
      integer    n,nmax
      real*4     dy,x,y,xa(n),ya(n),tiny
      parameter (nmax=10,tiny=1.e-25)
      integer    i,m,ns
      real*4     dd,h,hh,t,w,c(nmax),d(nmax)

      ns = 1
      hh = abs(x-xa(1))
      
      do i=1,n
        h=abs(x-xa(i))
        
        if(h.eq.0.)then 
          y=ya(i)
          dy=0.0
          
          return
        else if (h.lt.hh) then 
          ns = i
          hh=h
          
        endif
        c(i) = ya(i)
        d(i) = ya(i)+tiny
        
      enddo
      
      y=ya(ns)
      ns = ns -1 
      
      do m=1,n-1
        do i=1,n-m
          w=c(i+1)-d(i)
          h = xa(i+m) - x       ! h will never be zero, since this was
                                ! tested in the initializing loop.
          t = (xa(i)-x)*d(i)/h
          dd=t-c(i+1)
          
          if(dd.eq.0.) then 
            write(61,*)' ' 
            write(61,*)' Error condition '
            stop
          endif
          dd = w/dd
          d(i) = c(i+1)*dd
          c(i) =t*dd
          
        enddo
        
        if (2*ns.lt.n-m) then 
          dy=c(ns+1)
        else
          dy=d(ns)
          ns = ns -1
        endif
        y = y+dy

      enddo
      
      return
      end
