C*/
      SUBROUTINE READ_ELEC_RZ_FILES( ierror )
c
c This routine reads in the .rz (hbook) files which contains the hit
c distribution from electron showers

      INCLUDE 'km3.inc'
c
c  Local variables

      INTEGER*4 ierror, inrg, ir, ib, iomt, iomp, it, count
      INTEGER*4 rec_length,k,k2,numbad
      character*60 chrout

C Reset ERROR condition

      IERROR = 0
      
c the record length is the total number of time bins (el_sca_nbins(2,6)+1), plus
c the detection probability (1), in units of 4-byte reals; +2 for the zeroeth bin,
c and the detection probability
      rec_length=(el_sca_nbins(2,6)+2)*4
    
c records number of bins with zero hit probability
      numbad=0
      
c master loop over all the rz files in order of increasing energy
      do inrg = 1, el_sca_nbins(1,1) ! loop over shower energies

c open the input elec .rz file
      	 OPEN(UNIT=io_un_elec_rz, FILE=io_elec_rz_file(inrg),
     &      ACCESS='DIRECT', STATUS='OLD', FORM='UNFORMATTED',
     & 	    RECL=rec_length, IOSTAT=ierror)
     
      	 if (ierror.ne.0) then
      	    write (*,*) ' Error opening elec_rz file',ierror
      	    write (*,*) ' file name= ',IO_ELEC_RZ_FILE(inrg)
      	    return
      	 end if
      	 write(*,*) ' Did HROPEN for elec rz file',inrg,' ',io_elec_rz_file(inrg)

c loop over entries. Note the outer-to-inner indices are radii, band,
c OM theta, and OM phi. km3 splits the bands into two groups in two 
c separate arrays, which is physically nice, and computationally annoying.
      	 count=1
	    
	 do ir = 1, el_sca_nbins(1,2)  ! loop over shells
      	    do ib = el_sca_nbins(1,3),1,-1   ! loop over low bands (theta_track), and reverse direction of ib (so 0 is last)
      	       do iomt = 1, el_sca_nbins(1,4)
      	          do iomp = 1, el_sca_nbins(1,5)  ! loop over phi_OM orientations
		     READ(io_un_elec_rz,rec=count)
     &               	el_sca_prob(1,inrg,ir,ib,iomt,iomp),
     & (el_sca_time(1,inrg,ir,ib,iomt,iomp,it),it=0,el_sca_nbins(1,6))
      	             count = count+1
		     if (el_sca_prob(1,inrg,ir,ib,iomt,iomp) .eq. 0) then
			numbad = numbad+1
			el_sca_prob(1,inrg,ir,ib,iomt,iomp)=-40
      	             else
			el_sca_prob(1,inrg,ir,ib,iomt,iomp)=
     &               	   log(el_sca_prob(1,inrg,ir,ib,iomt,iomp))
      	             endif
                  enddo
               enddo
            enddo
	    do ib = 1, el_sca_nbins(2,3)   ! loop over high bands (theta_track)
      	       do iomt = 1, el_sca_nbins(2,4)
      	          do iomp = 1, el_sca_nbins(2,5)  ! loop over phi_OM orientations
      	             READ(io_un_elec_rz,rec=count)
     &               	el_sca_prob(2,inrg,ir,ib,iomt,iomp),
     & (el_sca_time(2,inrg,ir,ib,iomt,iomp,it),it=0,el_sca_nbins(2,6))
      	             count = count+1
		     if (el_sca_prob(2,inrg,ir,ib,iomt,iomp) .eq. 0) then
			el_sca_prob(2,inrg,ir,ib,iomt,iomp) = -40.
			numbad=numbad+1
		     else
			el_sca_prob(2,inrg,ir,ib,iomt,iomp) =
     &               	   log(el_sca_prob(2,inrg,ir,ib,iomt,iomp))
                     endif
		  enddo
               enddo
            enddo
      	 enddo
c close the input elec .rz file
         CLOSE(io_un_elec_rz)
      if (numbad .gt. 0) then
      	 write(*,*) 'found ',numbad,' bins in file ',
     &	       io_elec_rz_file(inrg)
      	 numbad=0
      endif
      
      enddo
      end
