      REAL FUNCTION VXDIST(PNT,PTR,V)
c     ------------------------------- 
c     find distance DIST between track (PTR,V) and point PNT            *
c
      REAL PTR(3),PNT(3),PT(3),V(3),A1,A2,A3
*
      PT(1)  = PTR(1)-PNT(1)
      PT(2)  = PTR(2)-PNT(2)
      PT(3)  = PTR(3)-PNT(3)
      A1     = V(2)*PT(3) - V(3)*PT(2)
      A2     = V(3)*PT(1) - V(1)*PT(3)
      A3     = V(1)*PT(2) - V(2)*PT(1)
      VXDIST = SQRT(A1*A1+A2*A2+A3*A3)
      RETURN
      END
      SUBROUTINE VXPROD(PNT,PTR,V,VXDIST,VPROD)
C     -----------------------------------------
C     Input : track PTR,V (V unit vector)
C             point PNT
C     Output: VPROD: distance from PTR along V
C             to point of closest approach of PNT 
C             VXDIST : shortest distance between track (PTR,V) 
C                      and point PNT
C
      REAL PTR(3),PNT(3),PT(3),V(3)
C
      PT(1)  = PNT(1)-PTR(1)
      PT(2)  = PNT(2)-PTR(2)
      PT(3)  = PNT(3)-PTR(3)
      A1     = V(2)*PT(3) - V(3)*PT(2)
      A2     = V(3)*PT(1) - V(1)*PT(3)
      A3     = V(1)*PT(2) - V(2)*PT(1)
      VXDIST = SQRT(A1*A1+A2*A2+A3*A3)
      VPROD  = (PT(1)*V(1)+PT(2)*V(2)+PT(3)*V(3))
      RETURN
      END
      SUBROUTINE VXNEW(V1,E,F,V2)
C     ---------------------------
C     calculates new vtx point V2 from
C     original vtx V1, unit vector E
C     and factor F
C
      REAL V1(3),V2(3),E(3),F
C
      DO I=1,3
       V2(I) = V1(I) + E(I)*F
      ENDDO
      RETURN
      END
      REAL FUNCTION CIRCLE(X)
C     -----------------------
C--- calculate fraction of circle area left after
C--- cut at x (-1,+1)
C 
      parameter (pi=3.1415926)
      circle = 0.5 + asin(x)/pi + sin(2.*asin(x))/2./pi
      return
      end
      SUBROUTINE ROTAEU(VOUT,VIN,PHI,THE,PSI)
C     ----------------------------------------
C--- rotation of space point with Euler angles
C--- cross check of signs with 
C--- EulerAngles::to_lab of Geometry.cc      
C
      REAL VOUT(3),VIN(3)
C
      VOUT(1) =
     +   VIN(1)*(  cos(phi)*cos(psi) - sin(phi)*sin(psi)*cos(the) ) + 
     +   VIN(2)*( -sin(phi)*cos(psi) - cos(phi)*sin(psi)*cos(the) ) + 
     +   VIN(3)*sin(psi)*sin(the)
      VOUT(2) =
     +   VIN(1)*(  cos(phi)*sin(psi) + sin(phi)*cos(psi)*cos(the) ) + 
     +   VIN(2)*( -sin(phi)*sin(psi) + cos(phi)*cos(psi)*cos(the) ) - 
     +   VIN(3)*cos(psi)*sin(the)
      VOUT(3) =
     +   VIN(1)*sin(phi)*sin(the) +
     +   VIN(2)*cos(phi)*sin(the) +
     +   VIN(3)*cos(the)
      RETURN
      END
      SUBROUTINE CHARANG(PHI,IFL,CHX)
C     -------------------------------
C     transforms angle (rad) into character string
C     including arc minutes and seconds
C     IFL = 1 lattitude
C     IFL = 2 longitude
C
      IMPLICIT NONE
C
      INCLUDE 'km3-params.inc'
C
      INTEGER IFL,IGRAD,IMIN,ISEC
      REAL PHI,PH,XMIN
      CHARACTER CHX*13,CHDIR*2,CHM*1,CHS*1
      DATA CHM /'`'/
      DATA CHS /'"'/
C       
      PH = PHI/PI*180.
      CHDIR = '  '
      CHX   = ' -not valid- '
      IF (IFL.EQ.1) THEN
       IF (ABS(PH).GT.90.) GOTO 99
       IF (PH.LT.0.) CHDIR = ' S'
       IF (PH.GT.0.) CHDIR = ' N'
      ELSEIF (IFL.EQ.2) THEN
       IF (ABS(PH).GT.180.) GOTO 99
       IF (PH.LT.0.) CHDIR = ' E'
       IF (PH.GT.0.) CHDIR = ' W'
      ELSE
       GOTO 99
      ENDIF
      PH = ABS(PH)
      IGRAD = INT(PH)
      XMIN  = 60.*(PH-FLOAT(IGRAD))
      IMIN  = INT(XMIN)
      ISEC  = INT(60.*(XMIN-IMIN))
      WRITE(CHX,'(I4,I3.2,A1,I2.2,A1,A2)') IGRAD,IMIN,CHM,ISEC,CHS,CHDIR
C
 99   CONTINUE
      RETURN
      END
