/* Make sure that FPE are trapped */ 
/* This code will be run before any main()/PROGRAM statement */

#define _GNU_SOURCE
#include <fenv.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

/* The following __attribute__ ensures that the code is run before main()!! */
static void __attribute__ ((constructor)) 
trap_fp_exceptions()
{
  /* The default is to trap FPE. Set the TRAPKM3FPE env to 0 to disable 
     this option. Any other numeric value with enable. */

  const char* trapfpe = getenv("TRAPKM3FPE");

  if(trapfpe && strlen(trapfpe) > 0 && atoi(trapfpe)==0) {
    printf("****** Disabling FPE exceptions! \n");
  } else {
    printf("****** Enabling FPE exceptions! Disable by setting the TRAPKM3FPE env var to 0\n");
    feenableexcept(FE_DIVBYZERO | FE_INVALID | FE_OVERFLOW);
  }
}
