C* Original author: Martin Moorhead<BR>
C* Original date: 27 July 1997<BR>
C*
C* For the current photon at point P_pos moving in direction P_dir, find out
C* where the next scattering interaction is.
C*
C* The interaction type is decided according to which of the following three
C* distances is the smallest:
C* - scat_dist
C* - bound_dist
C* Note that now the photon is *never* absorbed - it keeps going until
C* it leaves the instrumented volume, but accrues a cumulatively
C* reduced weight according to the probability that is has not yet
C* been absorbed
C*
C* @param scat_dist Input. The distance to the next scattering point
C* @param bound_dist Output. The distance to the next boundary.
C* @param int_type Output. 1=absorbed, 2=cross boundary, 3=scattered
C* @param new_region Output. Number of region on the other side of boundary
C*
C* @warning UNVERIFIED
C*/
      SUBROUTINE find_next_int(scat_dist,bound_dist,
     1                         int_type,new_region )

      include 'gen-geant.inc'
      include 'gen.inc'
      include 'gen-hit-ntuple.inc'

      INTEGER*4 int_type, new_region
      REAL*8    scat_dist, bound_dist
C
C--- find the distance to the next boundary
C
      call distance_to_boundary( bound_dist, new_region )

      int_type = 3  ! photon scatters

      if ( bound_dist .le. scat_dist ) then

         int_type = 2  ! photon hits boundary

      endif
      end
