C* This algoritm is from "a Monte Carlo Sampler" by
C* Everett and Cashwell, Los Alamos Informal Report LA-5061-MS, 10/72
C* in HEPG library E3. It gives an integer from a Poisson distribution with
C* the specified mean.
C*
C* @param avg Mean of the Poisson distribution
C*
C* @return Integer value sampled from a Poisson distribution with mean avg. -1 
C*         is returned if the input average is less than 0.
C*
C* @warning UNVERIFIED
C*/

        INTEGER Function RAN_POISSON(AVG)

        implicit none
        
        integer*4 idum, ier
        real*4    avg, z, t, ran_gauss, ran1

        ran_poisson=0
        IER=0

        IF(AVG.LT.0.) THEN
          IER = -1
          RETURN
        END If
C     
C ****  JEJ mod: put in Gaussian for large AVG.
C
        IF(AVG.GT.30.) THEN
*
* 26-Jan-2000 to avoid floating underflow exceptions on Linux:
*          ran_poisson = INT(avg+ran_gauss(idum)*SQRT(avg)+0.5)

          ran_poisson = INT(min(avg+ran_gauss(idum)*SQRT(avg)+0.5,2.E9))

          RETURN
        END IF
C
C ****  END JEJ
C
        Z=EXP(-AVG)
        T=1.
200     T=T*RAN1(IDUM)
 
        IF(T.LE.Z) return
        ran_poisson = ran_poisson+1
        if(ran_poisson .gt. 1000) return       !jgl installed max amplitude
        GO TO 200
 
        END
