C* Given a random number between 0 and 1, return cos(theta)
C* according to  scattering by particles
C* This is done by making an inverse linear interpolation from tabulated data
C*
C* @param r Input. A random number between 0 and 1
C* @param cosp Output. The cosine of the scattering angle
C*
C* @warning UNVERIFIED
C*/
        subroutine particle(r,cosp)

	include 'gen-water.inc'

        integer*4 k
        real*8 r,cosp
        real*8 angulo
   
        k = 1
        do while ( r.gt.part_acu(k))
         k = k + 1 
        enddo
        if (k.eq.1) then
         angulo = r * part_rad(1) / part_acu(1)
        else
         angulo = part_rad(k-1) + (r-part_acu(k-1))*
     &     (part_rad(k) - part_rad(k-1))/(part_acu(k)-part_acu(k-1))
        endif 
        cosp = cos(angulo)
        return
        end
