C*/
      REAL*4 FUNCTION anglediff(a,b)

** Calculate opening angle between any nonzero length vectors
** Opening angle is in RADIANS like all civilized angles.

*     Revision History:-
*     ================
c     V1	M. Moorhead	Taken from Wisconsin Amanda MC program

      INCLUDE 'km3.inc'

      REAL a(3),b(3)
      REAL aunit(3),bunit(3)
      REAL the_dot
      REAL vec_dot    ! Function
**
      CALL copy_vec(a,aunit,3)
      CALL copy_vec(b,bunit,3)  ! aunit,bunit now equal a,b

      CALL renorm_vec(aunit)
      CALL renorm_vec(bunit)    ! Now they are unit vectors
      the_dot = vec_dot(aunit,bunit)
      IF(the_dot.GT.1.) THEN  ! Deal with roundoff in dot product
         anglediff = 0.
      ELSE IF(the_dot.LT.-1.) THEN ! Deal with roundoff again
         anglediff = c_pi
      ELSE
         anglediff = acos(the_dot)
      END IF
      RETURN
      END
