C*/
      SUBROUTINE distance_to_string( point, string_center, 
     1                            string_half_height, closest )	

*     Created:  15-FEB-96
*     Contact:  M. Moorhead, LBNL.
*     Verified:

*     Purpose:-
*     =============
c     find the closest distance between a point and a vertical string. 

*     In/Out Variables:-
*     ==========
c     in	point        	xyz coordinates of the point	
c     in	string_center	xyz coordinates of the center of the string	
c     in	string_half_height
c     out       closest         distance of closest approach
 
*     Common Block Access:-
*     ===================
c     none

*     Assumptions:-
*     ===========
c     All quantities are in the same coordinate system! 
c     the string is VERTICAL, i.e. is parallel to the z-axis

*     Revision History:-
*     ================
c     V1	M. Moorhead	Created routine

      IMPLICIT NONE

      REAL*4  string_center(3), point(3), closest, string_half_height
      REAL*4  string_top(3), string_bot(3), string_point(3), vec_diff

      if ( point(3) .gt. string_center(3) + string_half_height ) then
c the point is above the top of the string

         call copy_vec( string_center, string_top, 3)
         string_top(3) = string_top(3) + string_half_height 
         closest = vec_diff(string_top, point)

      elseif ( point(3) .lt. string_center(3) - string_half_height )
     1         then
c the point is below the bottom of the string

         call copy_vec( string_center, string_bot, 3)
         string_bot(3) = string_bot(3) - string_half_height 
         closest = vec_diff(string_bot, point)

      else
c the point lies (in a vertical sense) between the top and bottom of the string

         call copy_vec( string_center, string_point, 3)
         string_point(3) = point(3) 
         closest = vec_diff(string_point, point)

      endif
      end
