C*/
      real function inter_time(x,ipol,om_num)
*************************************************************************
*     Name           :  inter_time                                      *
*     Called by      :                                                  *
*     Author         :  Juan Zuniga                                     *
*     Date           :  25-Jun-1999                                     *
*     Task           :  Compute time hit, sampling the inverse          *
*                    :  cumulative function with different              *
*                    :  interpolation approaches                        *
*                                                                       *
*  In/Out Variables:                                                    *
*  -----------------                                                    *
*   in     x           random variable                                  *
*   in     ipol = 1 : Polynomical interpolation taking thre points      *
*                      (Divided differences, using divdif routine from  *
*                      Cernlib                                          *
*   in     ipol = 2 : Rational interpolation taking thre points         *
*                      ( using ratint routine from Numerical recipes)   *
*************************************************************************
      include 'km3.inc'
      include 'km3-interpol.inc'

      real*4 x
      real*4 divdif,dy,rat_time

      integer*4 ipol,i_p,locatr,om_num
      integer*4 j,k,npoints
      parameter (npoints = 3)
     

      if (ipol.eq.1) then 
c-----------------------------------------------------------
c  Polynomical interpolation with three points
c-----------------------------------------------------------
       inter_time = divdif(f_time,a_time, phot_sca_nbins(5),x,2)
      elseif (ipol.eq.2) then
c-----------------------------------------------------------
c  Rational interpolation with three points
c-----------------------------------------------------------

       i_p = locatr(x_cheb,  phot_sca_nbins(5),x)
       j  =  abs(i_p)

       k = min ( max(j-(npoints-1)/2,1),phot_sca_nbins(5)+1+1-npoints)
       call ratint(a_time(k),f_time(k),npoints,x,rat_time,dy)
       inter_time = rat_time
      else
       write(61,*)' Inter_time error '
       write(61,*)' No time interpolation pattern given'
       write(61,*)' Check ipol ',ipol
       inter_time = -99999
      endif
      return
      end
