      subroutine initialize_music
      
      INCLUDE 'km3.inc'
      
c      implicit real*8 (a-h,o-z)

      REAL*8 n_a,n_z,n_rho,n_lambda

      integer*4 j0
      real*4 v2(201),cs1(201,71,4),cs2(201,71,4)
      real*4 emulo(81,7),emc(81)
      real*4 ema(61),va(30),anga(50),dang(50,30,61)
      real*8 e_cut, k, ro, i, il, j
      
      COMMON/sig/v2,cs1,cs2,j0
      COMMON/coenlo/emulo,emc
      COMMON/ang/ema,va,anga,dang
      COMMON/rock2/n_a,n_z,n_rho,n_lambda
      COMMON/cut/e_cut
      common/test/k

* Sea water description
cwj Incorrect? [n_z=7.507??? n_a=14.955?? if simple weighted sums?]
      n_z=6.8442      !Z, 11.00 for standard rock, 6.6 for pure water
      n_a=12.393      !A, 22.00 for standard rock, 11.89 for pure water
      n_rho=1.039      !density, 2.65 for standard rock
      n_lambda=36.08  !rad. length, 26.48 for standard rock
      ro=n_rho

*       reading of the muon energy losses
*      PRINT *,'music: loading energy losses table...'
c      OPEN(UNIT=4,file='km3-music-eloss.dat',
c     *  FORM='formatted',STATUS='old')
      OPEN(UNIT=4,file=M_eloss_file,
     *  FORM='formatted',STATUS='old')
      READ(4,99)emulo
   99 FORMAT(16(5E12.5/),E12.5/)
      CLOSE(4)

*       reading of the arrays with the normalized double differential
*       cross-section of muon inelastic scattering
*       log10(E_mu(GeV))= 0.0 - 6.0 with a step of 0.1 (ema(61))
*       log10(v)= -0.1 - -3.0 with a step of 0.1 (va(30))
*       log10(theta(rad))= 0.4 - -4.5 with a step of 0.1 (anga(50))
*       normalized double differential cross-section dang(50,30,61)
*       was calculated using the program sign_ang_arr.for with
*       the subroutine sign_ang.for
*      PRINT *,'music: loading inel. scatt. cross section...'
c      OPEN(UNIT=3,file='km3-music-double-diff.dat',
c     *  FORM='formatted',STATUS='old')
      OPEN(UNIT=3,file=M_double_diff_file,
     *  FORM='formatted',STATUS='old')
      READ(3,122)ema,va,anga,dang
  122 FORMAT(5e15.7)
      CLOSE(3)

C       J0 - THE MINIMAL VALUE OF RELATIVE ENERGY LOSSES (E/EMU);
C               STARTING FROM THIS VALUE ALL KINDS OF MUON ENERGY
C               LOSSES EXCEPT FOR IONISATION ARE TREATED AS THE
C               THE FLUCTUATED ONES, FOR EXAMPLE: J0=201 MEANS
C               THAT FROM V=E/EMU=10**(-10) UP TO V=1 THE LOSSES
C               ARE TREATED AS THE FLUCTUATED ONES.
C               THERE IS ALSO A CUT AT 10 MEV (e_cut). THE ENERGY LOSS LESS
C               THAN 10 MEV IS TREATED AS A CONTINUOUS ONE
      j0=201              !These two lines should be present
      e_cut=0.001  !GeV    ! in the main program

      DO I=1,201
        V2(I)=0.0-0.05*(I-1)
      END DO

      DO IL=1,81
        EMC(IL)=-1.0+0.1*(IL-1)
      END DO

C       READING THE INTEGRAL CROSS-SECTION
*      PRINT *,'music: loading integral cross sections...'
c      OPEN(UNIT=1,
c     *file='km3-music-cross-sections.dat',
c     *     FORM='formatted',STATUS='old')
      OPEN(UNIT=1,
     *file=M_xsection_file,
     *     FORM='formatted',STATUS='old')
      READ(1,3)CS2
    3 FORMAT(4(71(40(5E14.6/),e14.6/)/)/)
      CLOSE(UNIT=1)


C       FILLING THE ARRAY OF INTEGRAL CROSS-SECTIONS FOR THE SIMULATION

      do i=1,4
        do k=1,71
          do j=1,j0
             if(cs2(j0,k,i).gt.0.) then
      cs1(j,k,i)=cs2(j,k,i)/cs2(j0,k,i)
             end if
          end do
        end do
      end do

      return
      end
