      real function rantts(tts,ifl)
c     -----------------------------

c    Input:
c     tts (nsec) input for global tts - (sigma !)
c     ifl flag controls whether non-Gaussian tail is used
c     ifl = 0 pure Gaussian
c     ifl <> 0 full simulation
c    output
c     calculate time smearing due to non-Gaussian tts 
c     fonction laplace inverse Norm * (t/a)^(b-1) Exp(-t/a) 
c
      external ranlux 
c
      integer init
      real xg,xn,tsh,a,b,sig,ttsg
      save init,xg,xn,tsh,a,b,sig,ttsg
      data init /0/
c
      if (init.eq.0) then
        init = 1
       if (ifl.eq.0) then
        ttsg = 1.23  ! global tts for this reference sample
	xn   = 0.    ! relative normalisation of Laplace w.r.t. Gaussian
       else
        ttsg = 1.5   ! global tts for this reference sample (nsec)
        xn   = 0.936 ! relative normalisation of Laplace w.r.t. Gaussian
       endif
       tsh= 0.7    ! shift of Laplace w.r.t. Gaussian   (nsec)
       a  = 2.08   ! homothetie  (nsec)
       b  = 0.858  ! forme 
       sig= 1.23   ! Sigma Gaussian (nsec)
       xg = 2.5*sig/(2.5*sig+xn*gamma(b+1.)*a) ! relative fraction of Gaussian
      endif
c
      call ranlux(rat,1)
      if (rat.le.xg) then   ! take Gaussian part
       call rnormx(r,1,ranlux)
       rantts = r*sig*tts/ttsg 
      else                ! take Laplace part
       rantts = (rngama(b+1.)*a + tsh)*tts/ttsg
      endif
      end
