C*/
	SUBROUTINE READ_ANTARES_EVENT(status)
	INCLUDE 'km3.inc'
	INCLUDE 'km3-mass.inc'
	INCLUDE 'km3-params.inc'
c
c  Reads the next ANTARES event from the input event file and places the
c  particles (muons) into the p array

        INTEGER*4     STATUS, IDUMMY, I, J, IERR, EVTAGD, NTRUE, K
        INTEGER       NRUN, NEVENT, IEV, NDATEV
        LOGICAL       NEW_R,NEW_E
        CHARACTER*255 EVTAGN, CHX

cSMSM**********************************
c One-particle approximation variables, from M. Spurio
      real pvis(3),pvistot,evis,etot,ptot,opa_efrac,esum
      real xvis(3), Ekintot,Efrac,Ekin, pt0, hlength, opa_hlength
      real rtemp1,rtemp2
c     integer ipart,itrtyp,nwb,nmerged
      integer nmerged, ipart
c      real amass,charge,tlife,ub(10)
      real amass, eff_e
c        character*20 chnpar

c            CALL GFPART (IPART,CHNPAR,ITRTYP,AMASS,CHARGE,TLIFE,UB,NWB)
cSMSM**********************************
	status = 0
 10	continue
	CALL EVREAD(io_unevent,IERR) ! read next event
	if (ierr.ne.0) then
	  if (ierr.eq.2) GOTO 95
	  goto 99
	endif
	CALL EVINFO(NEW_R,NEW_E,NRUN,NEVENT,IEV)
c
c--- start-of-run event
c
	IF (NEW_R) THEN
	  WRITE(6,'('' another start-of-run found : ignored '',I5)')
	1      NRUN
	  GOTO 10
	ENDIF
c
c--- ignore non-physics events
c
	IF (IEV.NE.1) GOTO 10 
c
c--- delete old hits
c       
        IF (NDATEV('hit').GT.0) IDUMMY = EVTAGD('hit')
c
c--- read track informations
c       
	GEN_DADA_ID = NEVENT
	GEN_NPART   = NDATEV('track_in')
c
c--- add time stamp if needed
c
c	IF (NDATEV('time_stamp').EQ.0) THEN
c          WRITE(CHX,151) GEN_NOW_S,'.',GEN_NOW_NS
c          CALL EVTAGA('time_stamp',CHX,IERR)
c	ENDIF
*
        nmerged = 0
c        ntrue = 0
        k = 1
	pvistot=0.
	Ekintot=0.
	evis=0.
	xvis(1)=0.
	xvis(2)=0.
	xvis(3)=0.
	pvis(1)=0.
	pvis(2)=0.
	pvis(3)=0.
	
      GEN_NPARTIN=GEN_NPART

c sets minimum and maximum OPA ids: >min, <= maximum to be an OPA particle
      GEN_OPA_MAX=GEN_NPART
      GEN_OPA_MIN=GEN_NPART
      DO i=1,gen_npart

* 100	  CONTINUE
	  CHX = EVTAGN('track_in')
c only if it's a tau will the last two parameters exist
      	  READ(CHX,*) p_track_id(k),(p_x0(j,k),j=1,3),
     1      (p_v0(j,k),j=1,3),p_e0(k), p_t0(k),p_part_id(k),
     2      rtemp1,rtemp2
     
	    p_eff_seg(k) = 1  ! initial particles all begin at the first segment
	    p_nsegs(k) = 0 ! no segments yet!
c    Energy in GeV.
c    Vertex in meters.

c converts anti-muons to muons - this behaviour must be changed at a later date!   
      	 IF (p_part_id(k) .eq. p_id_muon+1) p_part_id(k) = p_id_muon
      	 IF (p_part_id(k) .eq. p_id_tau+1) p_part_id(k) = p_id_tau
	 IF (p_part_id(k) .eq. p_id_tau) tau_restlife(k)=rtemp2
c*********************** OPA ***********************************   
csm generation of TRACK_VIS
c  One-particle approximation: sums otherwise invisible energy over
c shower events, tracking the total momentum and energy of the products
c do NOT add neutrinos, tau or muons to the OPA weights
      	 IF(H_OPA.eq.1 .and. p_part_id(k) .ne. p_id_muon
     &	       .and. p_part_id(k) .ne. p_id_nu
     &	       .and. p_part_id(k) .ne. p_id_tau) then
      	    ipart=p_part_id(k)
      	    etot = p_e0(k)
c Loads particle data for this particle ID
      	    if (IPART .ge. 0 .and. IPART .lt. 50) then
	        AMASS=AMASSS(IPART+1)
	    else
	       AMASS=0.
	    endif
	    
	    IF (ETOT .GT. AMASS) THEN
      	       PTOT = SQRT(ETOT*ETOT - AMASS*AMASS)
c now weights total momentum by returned energy-fraction
      	       Ekin=ETOT-AMASS
      	       Efrac=OPA_EFRAC(ipart,Ekin)
      	       if (Efrac .gt. 0.) then
		  pvis(1) = Efrac*ptot*p_v0(1,k) + pvis(1)
      	          pvis(2) = Efrac*ptot*p_v0(2,k) + pvis(2)
      	          pvis(3) = Efrac*ptot*p_v0(3,k) + pvis(3)
		  xvis(1) = Efrac*Ekin*p_x0(1,k) + xvis(1)
		  xvis(2) = Efrac*Ekin*p_x0(2,k) + xvis(2)
		  xvis(3) = Efrac*Ekin*p_x0(3,k) + xvis(3)
      	          pvistot= pvistot + ptot*Efrac
		  Ekintot = Ekintot+Ekin*Efrac
      	          evis = evis+Efrac*Ekin
c		  write(*,*) 'Ekin/ipart/efrac', Ekin, ipart, Efrac
	          nmerged = nmerged+1
		  pt0=p_t0(k)
	       endif
            ENDIF   ! fine IF su ptot>0
c Multi-particle approximation: converts each non-muon/neutrino/tau
c to effective electrons, and offsets each cascade by a characteristic
c shower length.          
	  ELSEIF (H_OPA.eq.2.and.p_part_id(k).ne.p_id_muon
     &	       .and. p_part_id(k) .ne. p_id_nu
     &	       .and. p_part_id(k) .ne. p_id_tau) then
c OPA operates separately for each particle
	    ipart=p_part_id(k)
            etot = p_e0(k)
	    
c Loads particle data for this particle ID
      	    if (IPART .ge. 0 .and. IPART .lt. 50) then
	        AMASS=AMASSS(IPART+1)
	    else
	       AMASS=0.
	    endif
	    
	    IF (ETOT .GT. AMASS) THEN
      	       PTOT = SQRT(ETOT*ETOT - AMASS*AMASS)
c now weights total momentum by returned energy-fraction
      	       Ekin=ETOT-AMASS
      	       Efrac=OPA_EFRAC(ipart,Ekin)
	       Eff_e=Efrac*Ekin
	       
      	       if (Efrac .gt. 0.) then
c calculates offset relative to an electron (>0 = longer)
		  hlength=opa_hlength(ipart,Ekin)
     &               -opa_hlength(3,Eff_e)
c adds offset used in generating the electron tables
      	          if (eff_e .gt. 0.1) then
		     hlength = hlength+0.9*(1.0+log10(Eff_e))/1.0398
		  endif
		  
		  GEN_OPA_MAX=GEN_OPA_MAX+1
c      	          gen_npart = GEN_OPA_MAX
      	          GEN_NPARTIN = GEN_NPARTIN+1
      	          p_track_id(GEN_NPARTIN) = GEN_NPARTIN
      	          p_v0(1,GEN_OPA_MAX) = p_v0(1,k)
      	          p_v0(2,GEN_OPA_MAX) = p_v0(2,k)
      	          p_v0(3,GEN_OPA_MAX) = p_v0(3,k)
      	          p_x0(1,GEN_OPA_MAX) = p_x0(1,k) + p_v0(1,k)*hlength
      	          p_x0(2,GEN_OPA_MAX) = p_x0(2,k) + p_v0(2,k)*hlength
      	          p_x0(3,GEN_OPA_MAX) = p_x0(3,k) + p_v0(3,k)*hlength
      	          p_e0(GEN_OPA_MAX) = Eff_e+AMASSS(3)
      	          p_t0(GEN_OPA_MAX) = p_t0(k)+
     &	             	   hlength*xmeter/clight
		  p_part_id(GEN_OPA_MAX) = H_OPA_ID
      	          p_nsegs(GEN_OPA_MAX) = 0
      	          p_eff_seg(GEN_OPA_MAX) = 1
	          nmerged = nmerged+1
		  p_iparent(GEN_OPA_MAX)=k
	       endif
            ENDIF
	 ENDIF
csm     
c***********************END OPA********************************   

	    p_iparent(k) = 0	! Parent particle number (zero for initials)
            k = k+1
C          END IF
c <<<<<< 
        ENDDO
c        gen_npart = ntruen
c        GEN_NPARTIN = ntrue
      	 gen_npart=GEN_NPARTIN
csm ******************* OPA ************************
        IF(nmerged .gt. 0 .and.H_OPA.eq.1) then
	  if(pvistot.eq.0) goto 95
          GEN_OPA_MAX=GEN_OPA_MAX+1
	  gen_npart =   gen_npart+1  
          GEN_NPARTIN = GEN_NPARTIN+1
          k = GEN_NPARTIN
	  hlength=OPA_HLENGTH(3,evis)
          p_track_id(k) = k
	  p_v0(1,k) = pvis(1)/pvistot 
          p_v0(2,k) = pvis(2)/pvistot
          p_v0(3,k) = pvis(3)/pvistot
	  p_x0(1,k) = xvis(1)/Ekintot
	  p_x0(2,k) = xvis(2)/Ekintot
	  p_x0(3,k) = xvis(3)/Ekintot
	  p_x0(1,k) = p_x0(1,k) + hlength*p_v0(1,k)
	  p_x0(2,k) = p_x0(2,k) + hlength*p_v0(2,k)
	  p_x0(3,k) = p_x0(3,k) + hlength*p_v0(3,k)
          p_e0(k) = evis
          p_t0(k) = pt0 + hlength*xmeter/clight
	  p_nsegs(k) = 0
          p_part_id(k) = H_OPA_ID
	  p_iparent(k)=k
	  p_eff_seg(k) = 1   ! initial particle always starts at 0
        ENDIF     ! fine IF su evt_type(1)
csm c***********************END OPA**********************

94      continue
* Delete all track_in tags from the buffer. They will be re-copied in
* SUBROUTINE PROCESS_EVENT including the track length information.
* Change to function for LINUX
*
C*	CALL EVTAGD('track_in')
        IDUMMY = EVTAGD('track_in')
*
        gen_nhits    = 0	! reset total # of hits in event 
        return 

 95     WRITE(*,*) ' End of ANTARES event file, event No.: ',
     &  gen_event_id 
        status = 1		! 1 = EOF reached
        return

 99	status = 2		! 2 = error in reading EVENT
        WRITE(*,*) 'ERROR reading EVENT'
        return 
 151	FORMAT(I9.9,A1,I9.9)

        END
