C*/
      SUBROUTINE READ_PHOTON_RZ_FILE(ierror)
*************************************************************************
*     Name           :  READ_PHOTON_RZ_FILE                             *
*     Called by      :                                                  *
*     Author         :  Sergio Navas                                    *
*     Date           :  20-Sep-1998                                     *
*     Task           :                                                  *
*                                                                       *
* This routine reads in the .rz (hbook) file which contains all the     *
* distribution from photons (LASER flash simulation)                    *
*                                                                       *
*  In/Out Variables:                                                    *
*  -----------------                                                    *
*                                                                       *
*************************************************************************
*
      INCLUDE 'km3.inc'
c
c  Local variables

      INTEGER*4 ierror, ir, ib, iomt, iomp, it, count, rec_length
      character*60 chrout

C Reset ERROR condition

      IERROR = 0
      rec_length=4*(phot_dir_nbins(4)+2)
      
c open the input photon .rz file
      OPEN(UNIT=io_un_photon_rz, FILE=io_photon_rz_file,
     &      ACCESS='DIRECT', STATUS='OLD', FORM='UNFORMATTED',
     & 	    RECL=rec_length, IOSTAT=ierror)
     
      if (ierror.ne.0) then
         write (*,*) ' Error opening photon_rz file',ierror
         write (*,*) ' file name= ',IO_PHOTON_RZ_FILE
         return
      end if
      write(*,*) ' Did OPEN for photon rz file ',io_photon_rz_file
      
      count=1
      do ir=1, phot_dir_nbins(1)
      	 do ib=1, phot_dir_nbins(2)
	    do iomt=phot_dir_nbins(3),1,-1
	       READ(io_un_photon_rz,count) phot_dir_prob(ir,ib,iomt),
     & (phot_dir_time(ir,ib,iomt,it),it=0,phot_dir_nbins(4))
	       count = count+1
	       if (phot_dir_prob(ir,ib,iomt) .eq. 0) then
	          phot_dir_prob(ir,ib,iomt)=-40.
	       else
	          phot_dir_prob(ir,ib,iomt)=log(phot_dir_prob(ir,ib,iomt))
	       endif
	    enddo
	 enddo
      enddo
c now scattered photons

      do ir=1, phot_sca_nbins(1)
      	 do ib=1, phot_sca_nbins(2)
	    do iomt=1,phot_sca_nbins(3)
	       do iomp=1, phot_sca_nbins(4)
	          READ(io_un_photon_rz,count)
     & phot_sca_prob(ir,ib,iomt,iomp),
     & (phot_sca_time(ir,ib,iomt,iomp,it),it=0,phot_sca_nbins(5))
	          count = count+1
	          if (phot_sca_prob(ir,ib,iomt,iomp) .eq. 0) then
	             phot_sca_prob(ir,ib,iomt,iomp)=-40.
	          else
	             phot_sca_prob(ir,ib,iomt,iomp)=log(phot_sca_prob(ir,ib,iomt,iomp))
	          endif
	       enddo
	    enddo
	 enddo
      enddo
      
      


c close the input photon .rz file and clear the ntuples from local paw memory

      close(io_un_photon_rz)
*
**
*
 999	CONTINUE
        END
