C*       Last Modified: 19-Jul-1999 (LT) 
C*                      Remove call to PRESENTA
C*                      MAJOR rewrite to use card input for all variables
C*
C*  This routine reads in the user inputs from the interactive session
C*  (or the script file running the batch)
C*  NB (19/07/99) Now all user input comes from external cards file
C*
C*/
      SUBROUTINE READ_USER_INPUTS(status)

      INCLUDE 'km3.inc'
      INCLUDE 'km3-cards.inc'
      
c  Local variables

      INTEGER*4   status , ILINE , I 
      REAL*4      min_seg_ratio
      CHARACTER*5   chcard
      CHARACTER*126 chline
      LOGICAL lmore

      CHARACTER*200 hbmuon,hbele1,hbele2,hbele3,hbele4
      CHARACTER*200 demuon,deele1,deele2,deele3,deele4
c      CHARACTER*200 hbdisp
*
* Logical variables (one per card) to keep track of whether the card
* has been set by the user

      LOGICAL L_CHGEO
      LOGICAL L_CHINP
      LOGICAL L_CHNEV
      LOGICAL L_CHNSG
      LOGICAL L_CHOUT
      LOGICAL L_CHPHD
      LOGICAL L_CHPHH
      LOGICAL L_CHSCA
      LOGICAL L_CHTYP
      LOGICAL L_IEFIL 
      LOGICAL L_IGAIN  
      LOGICAL L_IEMPT  
      LOGICAL L_IIFMT  
      LOGICAL L_INEVT   
      LOGICAL L_IOFMT   
      LOGICAL L_INPOL
      LOGICAL L_IPT40   
      LOGICAL L_IRAND
      LOGICAL L_INGRP
      LOGICAL L_XMCUT   
      LOGICAL L_XMSTP   
*      LOGICAL L_XRANG
      LOGICAL L_XSEGR   
      LOGICAL L_XSTHR
      LOGICAL L_XMERG
      LOGICAL L_XRAWH
      LOGICAL L_LMUSI
      LOGICAL L_LPDIR   
      LOGICAL L_LPSCA   
      LOGICAL L_LVERB   
      LOGICAL L_LWNEV   
      LOGICAL L_LWNSG   
      LOGICAL L_DODIR
      LOGICAL L_ELREC
      LOGICAL L_INOPA
      LOGICAL L_DIVTK
      LOGICAL L_RECHO
      LOGICAL L_OPAID
      LOGICAL L_TAUDE
*
*  Definitions file for all user-controlled variables that can be set
*  in an external cards file. Default values for each card are stored
*  here in the variable name "<cardname>_DEF" for those cases where a card
*  is not set by the user. 
*
      CHARACTER*120  CHGEO
      CHARACTER*120  CHINP
      CHARACTER*120  CHNEV
      CHARACTER*120  CHNSG
      CHARACTER*120  CHOUT
      CHARACTER*120  CHPHD
      CHARACTER*120  CHPHH
      CHARACTER*13   CHSCA
      CHARACTER*8    CHTYP
*
      INTEGER*4        IEFIL    
      INTEGER*4        IGAIN    
      INTEGER*4        IEMPT  
      INTEGER*4        IIFMT    
      INTEGER*4        INEVT    
      INTEGER*4        IOFMT    
      INTEGER*4        INPOL
      INTEGER*4        IPT40(2) 
      INTEGER*4        IRAND(4) 
      INTEGER*4        INGRP
      
      INTEGER*4      DODIR
      INTEGER*4      ELREC
      INTEGER*4      INOPA
      INTEGER*4      RECHO
      INTEGER*4      OPAID
*			     
      REAL*4           XMCUT(4)    
      REAL*4           XMSTP    
*      REAL*4           XRANG
      REAL*4           XSEGR    
      REAL*4           XSTHR
      REAL*4           XMERG
      INTEGER*4        XRAWH(3)
      REAL*4           DIVTK
      REAL*4         TAUDE
*
      LOGICAL        LMUSI 
      LOGICAL        LPDIR    
      LOGICAL        LPSCA    
      LOGICAL        LVERB    
      LOGICAL        LWNEV    
      LOGICAL        LWNSG    

      COMMON /FF64BIT/ CHTYP,IPT40,IRAND,XRAWH,IEFIL,IGAIN,IEMPT,IIFMT,
     + INEVT,IOFMT,INPOL,INGRP,XMCUT,XMSTP,XSEGR,XSTHR,XMERG,
     + LMUSI,LPDIR,LPSCA,LVERB,LWNEV,LWNSG,DODIR,ELREC,INOPA,DIVTK,
     + RECHO, OPAID

* Initialise job card summary
      CALL INIT_SUMMARY
     
* For each card (except mandatory ones) set to default before setting by user

      CHNEV = CHNEV_DEF 
      CHNSG = CHNSG_DEF 
      CHPHD = CHPHD_DEF 
      CHPHH = CHPHH_DEF 
      CHTYP = CHTYP_DEF 
      IEFIL = IEFIL_DEF 
      IGAIN = IGAIN_DEF 
      IEMPT = IEMPT_DEF 
      IIFMT = IIFMT_DEF 
      INEVT = INEVT_DEF 
      IOFMT = IOFMT_DEF 
      INPOL = INPOL_DEF
      IPT40(1) = IPT40_DEF(1)
      IPT40(2) = IPT40_DEF(2)
      CHSCA = ''
      
      DODIR = DODIR_DEF
      ELREC = ELREC_DEF
      INOPA = INOPA_DEF
      DIVTK = DIVTK_DEF
      RECHO = RECHO_DEF
      OPAID = OPAID_DEF
      
      LMUSI = LMUSI_DEF 
      LPDIR = LPDIR_DEF 
      LPSCA = LPSCA_DEF 
      LVERB = LVERB_DEF 
      LWNEV = LWNEV_DEF 
      LWNSG = LWNSG_DEF 
      XMCUT(1) = XMCUT_DEF(1)
      XMCUT(2) = XMCUT_DEF(2)
      XMCUT(3) = XMCUT_DEF(3)
      XMCUT(4) = XMCUT_DEF(4)
      XMSTP = XMSTP_DEF 
*      XRANG = XRANG_DEF 
      XSEGR = XSEGR_DEF 
      XSTHR = XSTHR_DEF 
      XMERG = XMERG_DEF 
      XRAWH(1) = XRAWH_DEF(1)
      XRAWH(2) = XRAWH_DEF(2)
      XRAWH(3) = XRAWH_DEF(3)
      IRAND(1) = -1
      INGRP = INGRP_DEF
      TAUDE=TAUDE_DEF

      L_CHGEO = .FALSE.
      L_CHINP = .FALSE.
      L_CHNEV = .FALSE.
      L_CHNSG = .FALSE.
      L_CHOUT = .FALSE.
      L_CHPHD = .FALSE.
      L_CHPHH = .FALSE.
      L_CHSCA = .FALSE.
      L_CHTYP = .FALSE.
      L_IEFIL = .FALSE.  
      L_IGAIN = .FALSE.   
      L_IEMPT = .FALSE.   
      L_IIFMT = .FALSE.   
      L_INEVT = .FALSE.    
      L_IOFMT = .FALSE.    
      L_INPOL = .FALSE.    
      L_INGRP = .FALSE.
      L_IPT40 = .FALSE.    
      L_IRAND = .FALSE. 
      L_XMCUT = .FALSE.    
      L_XMSTP = .FALSE.    
*      L_XRANG = .FALSE.
      L_XSEGR = .FALSE.    
      L_XSTHR = .FALSE.
      L_XMERG = .FALSE.
      L_XRAWH = .FALSE.
      L_LMUSI = .FALSE. 
      L_LPDIR = .FALSE.    
      L_LPSCA = .FALSE.    
      L_LVERB = .TRUE.    
      L_LWNEV = .FALSE.    
      L_LWNSG = .FALSE.    
      L_DODIR = .FALSE.
      L_ELREC = .FALSE.
      L_INOPA = .FALSE.
      L_DIVTK = .FALSE.
      L_RECHO = .FALSE.
      L_OPAID = .FALSE.
      L_TAUDE = .FALSE.
      
C D. Bailey 9/1/01
C   Instead of reading from a separate cards file on UNIT 19 (whose filename
C   differs between platforms), read from stdin using FFREAD cards.
      
      CALL FFINIT(IFFSZE)
      
      CALL FFSET('SIZE',5)
      CALL FFKEY('EVTYP',CHTYP,8,'MIXED')
      CALL FFKEY('IEFIL',IEFIL,1,'INT')
      CALL FFKEY('IGAIN',IGAIN,1,'INT')
      CALL FFKEY('IEMPT',IEMPT,1,'INT')
      CALL FFKEY('IIFMT',IIFMT,1,'INT')
      CALL FFKEY('INEVT',INEVT,1,'INT')
      CALL FFKEY('IOFMT',IOFMT,1,'INT')
      CALL FFKEY('INPOL',INPOL,1,'INT')
      CALL FFKEY('IPT40',IPT40,2,'INT')
      CALL FFKEY('IRAND',IRAND,4,'INT')
      CALL FFKEY('INGRP',INGRP,1,'INT')
      CALL FFKEY('LMUSI',LMUSI,1,'LOGICAL')
      CALL FFKEY('LPDIR',LPDIR,1,'LOGICAL')
      CALL FFKEY('LPSCA',LPSCA,1,'LOGICAL')
      CALL FFKEY('LVERB',LVERB,1,'LOGICAL')
      CALL FFKEY('LWNEV',LWNEV,1,'LOGICAL')
      CALL FFKEY('LWNSG',LWNSG,1,'LOGICAL')
      CALL FFKEY('XMCUT',XMCUT,4,'REAL')
      CALL FFKEY('XMSTP',XMSTP,1,'REAL')
*      CALL FFKEY('XRANG',XRANG,1,'REAL')
      CALL FFKEY('XSEGR',XSEGR,1,'REAL')
      CALL FFKEY('XSTHR',XSTHR,1,'REAL')
      CALL FFKEY('XMERG',XMERG,1,'REAL')
      CALL FFKEY('DIVTK',DIVTK,1,'REAL')
      CALL FFKEY('XRAWH',XRAWH,3,'INT')
      CALL FFKEY('DODIR',DODIR,1,'INT')
      CALL FFKEY('ELREC',ELREC,1,'INT')
      CALL FFKEY('INOPA',INOPA,1,'INT')
      CALL FFKEY('RECHO',RECHO,1,'INT')
      CALL FFKEY('OPAID',OPAID,1,'INT')
      CALL FFKEY('TAUDE',TAUDE,1,'REAL')
      CALL FFGO
      
* Define the names of the ntuples and .desc files to be used ...
      IF (CHTYP.EQ.'EVT_MUON') THEN
        CALL GETENV('hbmuon',hbmuon)  ! 100 GeV muons
        CALL GETENV('hbele1',hbele1)  ! 0.1 GeV showers
        CALL GETENV('hbele2',hbele2)  !   1 GeV showers
        CALL GETENV('hbele3',hbele3)  !  10 GeV showers
        CALL GETENV('hbele4',hbele4)  ! 100 GeV showers

        CALL GETENV('demuon',demuon)  ! 100 GeV muons
        CALL GETENV('deele1',deele1)  ! 0.1 GeV showers
        CALL GETENV('deele2',deele2)  !   1 GeV showers
        CALL GETENV('deele3',deele3)  !  10 GeV showers
        CALL GETENV('deele4',deele4)  ! 100 GeV showers
      
      ELSE IF (CHTYP.EQ.'EVT_LASE') THEN

        CALL GETENV('hbphot',CHPHH)
        CALL GETENV('dephot',CHPHD)

      ENDIF
      
      
C--- If the group velocity is set to include dispersion, get the filename

c      IF (INGRP.EQ.2) THEN
c        CALL GETENV('hbdisp',HBDISP)
c      ENDIF

C Get the names of the input, output and geometry files

      CALL GETENV('EVIFIL',CHINP)
      CALL GETENV('EVOFIL',CHOUT)
      CALL GETENV('GEOFIL',CHGEO)
      CALL GETENV('NEVFIL',CHNEV)
      CALL GETENV('NSGFIL',CHNSG)
 
      io_muon_desc_file = demuon
      io_muon_rz_file   = hbmuon
      
      io_elec_desc_file(1) = deele1
      io_elec_desc_file(2) = deele2
      io_elec_desc_file(3) = deele3
      io_elec_desc_file(4) = deele4
      io_elec_rz_file(1)   =  hbele1
      io_elec_rz_file(2)   =  hbele2
      io_elec_rz_file(3)   =  hbele3
      io_elec_rz_file(4)   =  hbele4
c      io_dispersion_rz_file = hbdisp
      
      write(*,*) io_elec_desc_file(1)
      write(*,*) io_elec_desc_file(2)
      write(*,*) io_elec_desc_file(3)
      write(*,*) io_elec_desc_file(4)
      write(*,*) io_elec_rz_file(1)
      write(*,*) io_elec_rz_file(2)
      write(*,*) io_elec_rz_file(3)
      write(*,*) io_elec_rz_file(4)
* Initialise logical variables to flag that variable has been user defined
      status = 0

* Process mandatory cards which, if missing cause the job to fail and 
C validate the input

      IF (XMERG.LT.0.1) THEN
        XMERG = 0.1
	WRITE(*,*) '** Warning XMERG too small -> fixed to 0.1 ns'
      ENDIF

      IF (CHINP.EQ.'') THEN
        WRITE(6,*) '*** No input file specified, use environment',
     &             ' variable EVIFIL'
        WRITE(6,*) '*** km3mc job is terminating due to card file error'
        status = 1
      ENDIF
      IF (CHOUT.EQ.'') THEN
        WRITE(6,*) '*** No output file specified, use environment',
     &             ' variable EVOFIL'
        WRITE(6,*) '*** km3mc job is terminating due to card file error'
        status = 1
      ENDIF
      IF (HBMUON.EQ.'') THEN
        WRITE(6,*) '*** No scattering model specified, use environment',
     &             ' variables hb* and de*'
        WRITE(6,*) '*** km3mc job is terminating due to card file error'
        status = 1
      ENDIF
      IF (CHGEO.EQ.'') THEN
        WRITE(6,*) '*** No geometry file specified, use environment',
     &             ' variable GEOFIL'
        WRITE(6,*) '*** km3mc job is terminating due to card file error'
        status = 1
      ENDIF
      IF (IRAND(1).EQ.-1) THEN
        WRITE(6,*) 
     *    '*** No random number seed specified, use card IRAND'
        WRITE(6,*) '*** km3mc job is terminating due to card file error'
        status = 1
      ENDIF

C Check which parameters have been changed from their default values 
C for the job summary below

      IF (CHGEO.NE.'') L_CHGEO = .TRUE.
      IF (CHINP.NE.'') L_CHINP = .TRUE.
      IF (CHNEV.NE.'') THEN 
        L_CHNEV = .TRUE.
      ELSE
        CHNEV = CHNEV_DEF
      ENDIF
      IF (CHNSG.NE.'') THEN
        L_CHNSG = .TRUE.
      ELSE
        CHNSG = CHNSG_DEF
      ENDIF
      IF (CHOUT.NE.'') L_CHOUT = .TRUE.
      IF (CHPHD.NE.CHPHD_DEF) L_CHPHD = .TRUE.
      IF (CHPHH.NE.CHPHH_DEF) L_CHPHH = .TRUE.
      IF (CHTYP.NE.CHTYP_DEF) L_CHTYP = .TRUE.
      IF (IEFIL.NE.IEFIL_DEF) L_IEFIL = .TRUE.
      IF (IGAIN.NE.IGAIN_DEF) L_IGAIN = .TRUE.
      IF (IEMPT.NE.IEMPT_DEF) L_IEMPT = .TRUE.
      IF (IIFMT.NE.IIFMT_DEF) L_IIFMT = .TRUE.
      IF (INEVT.NE.INEVT_DEF) L_INEVT = .TRUE.
      IF (IOFMT.NE.IOFMT_DEF) L_IOFMT = .TRUE.
      IF (INPOL.NE.INPOL_DEF) L_INPOL = .TRUE.
      IF (INGRP.NE.INGRP_DEF) L_INGRP = .TRUE.
      IF (IPT40(1).NE.IPT40_DEF(1)) L_IPT40 = .TRUE.
      IF (IRAND(1).NE.-1) L_IRAND = .TRUE.
      IF (LMUSI.NEQV.LMUSI_DEF) L_LMUSI = .TRUE.
      IF (LVERB.NEQV.LVERB_DEF) L_LVERB = .TRUE.
      IF (LWNEV.NEQV.LWNEV_DEF) L_LWNEV = .TRUE.
      IF (LWNSG.NEQV.LWNSG_DEF) L_LWNSG = .TRUE.
      IF (XMCUT(1).NE.XMCUT_DEF(1)) L_XMCUT = .TRUE.
      IF (XMCUT(2).NE.XMCUT_DEF(2)) L_XMCUT = .TRUE.
      IF (XMCUT(3).NE.XMCUT_DEF(3)) L_XMCUT = .TRUE.
      IF (XMCUT(4).NE.XMCUT_DEF(4)) L_XMCUT = .TRUE.
      IF (XMSTP.NE.XMSTP_DEF) L_XMSTP = .TRUE.
*      IF (XRANG.NE.XRANG_DEF) L_XRANG = .TRUE.
      IF (XSEGR.NE.XSEGR_DEF) L_XSEGR = .TRUE.
      IF (XSTHR.NE.XSTHR_DEF) L_XSTHR = .TRUE.
      IF (XMERG.NE.XMERG_DEF) L_XMERG = .TRUE.
      IF (XRAWH(1).NE.XRAWH_DEF(1)) L_XRAWH = .TRUE.
      IF (DODIR.NE.DODIR_DEF) L_DODIR = .TRUE.
      IF (ELREC.NE.ELREC_DEF) L_ELREC = .TRUE.
      IF (INOPA.NE.INOPA_DEF) L_INOPA = .TRUE.
      IF (DIVTK.NE.DIVTK_DEF) L_DIVTK = .TRUE.
      IF (RECHO.NE.RECHO_DEF) L_RECHO = .TRUE.
* Now transfer card settings into the job summary

      IF ( L_CHGEO ) WRITE ( CHSUMM( 1)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_CHINP ) WRITE ( CHSUMM( 2)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_CHNEV ) WRITE ( CHSUMM( 3)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_CHNSG ) WRITE ( CHSUMM( 4)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_CHOUT ) WRITE ( CHSUMM( 5)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_CHPHD ) WRITE ( CHSUMM( 6)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_CHPHH ) WRITE ( CHSUMM( 7)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_CHSCA ) WRITE ( CHSUMM( 8)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_CHTYP ) WRITE ( CHSUMM( 9)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_IEFIL ) WRITE ( CHSUMM(10)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_IGAIN ) WRITE ( CHSUMM(11)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_IEMPT ) WRITE ( CHSUMM(12)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_IIFMT ) WRITE ( CHSUMM(13)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_INEVT ) WRITE ( CHSUMM(14)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_IOFMT ) WRITE ( CHSUMM(15)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_INPOL ) WRITE ( CHSUMM(16)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_IPT40 ) WRITE ( CHSUMM(17)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_IRAND ) WRITE ( CHSUMM(18)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_LMUSI ) WRITE ( CHSUMM(19)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_LVERB ) WRITE ( CHSUMM(20)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_LWNEV ) WRITE ( CHSUMM(21)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_LWNSG ) WRITE ( CHSUMM(22)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_XMCUT ) WRITE ( CHSUMM(23)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_XMSTP ) WRITE ( CHSUMM(24)(67:77) , '(A11)' ) 'SET BY USER'
*      IF ( L_XRANG ) WRITE ( CHSUMM(25)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_XSEGR ) WRITE ( CHSUMM(26)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_XSTHR ) WRITE ( CHSUMM(27)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_XMERG ) WRITE ( CHSUMM(28)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_XRAWH ) WRITE ( CHSUMM(29)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_INGRP ) WRITE ( CHSUMM(30)(67:77) , '(A11)' ) 'SET BY USER'
      IF ( L_DIVTK ) WRITE ( CHSUMM(31)(67:77) , '(A11)' ) 'SET BY USER'
c      IF ( L_DODIR ) WRITE ( CHSUMM(32)(67:77) , '(A11)' ) 'SET BY USER'
c      IF ( L_ELREC ) WRITE ( CHSUMM(33)(67:77) , '(A11)' ) 'SET BY USER'
c      IF ( L_INOPA ) WRITE ( CHSUMM(34)(67:77) , '(A11)' ) 'SET BY USER'
c      IF ( L_RECHO ) WRITE ( CHSUMM(35)(67:77) , '(A11)' ) 'SET BY USER'
      
      CALL CHAR_SUMMARY ( CHGEO,  1)
      CALL CHAR_SUMMARY ( CHINP,  2)
      CALL CHAR_SUMMARY ( CHOUT,  5)

      WRITE ( CHSUMM( 8)(34:46) , '(A13)' ) CHSCA
      WRITE ( CHSUMM( 9)(34:41) , '(A8)' ) CHTYP
      WRITE ( CHSUMM(10)(34:41) , '(I8)' ) IEFIL
      WRITE ( CHSUMM(11)(34:41) , '(I8)' ) IGAIN
      WRITE ( CHSUMM(12)(34:41) , '(I8)' ) IEMPT
      WRITE ( CHSUMM(13)(34:41) , '(I8)' ) IIFMT
      WRITE ( CHSUMM(14)(34:41) , '(I8)' ) INEVT
      WRITE ( CHSUMM(15)(34:41) , '(I8)' ) IOFMT
      WRITE ( CHSUMM(16)(34:41) , '(I8)' ) INPOL
      WRITE ( CHSUMM(17)(34:49) , '(2I8)' ) ( IPT40(I) , I = 1,2 )
      WRITE ( CHSUMM(18)(34:61) , '(4I7)' ) ( IRAND(I) , I=1,4 )
      IF ( .NOT. LMUSI ) WRITE ( CHSUMM(19)(34:38) , '(A5)' ) 'FALSE'
      IF ( .NOT. LVERB ) WRITE ( CHSUMM(20)(34:38) , '(A5)' ) 'FALSE'
      IF ( .NOT. LWNEV ) WRITE ( CHSUMM(21)(34:38) , '(A5)' ) 'FALSE'
      IF ( .NOT. LWNSG ) WRITE ( CHSUMM(22)(34:38) , '(A5)' ) 'FALSE'
      IF (  LMUSI )      WRITE ( CHSUMM(19)(34:38) , '(A5)' ) 'TRUE '
      IF (  LVERB )      WRITE ( CHSUMM(20)(34:38) , '(A5)' ) 'TRUE '
      IF (  LWNEV )      WRITE ( CHSUMM(21)(34:38) , '(A5)' ) 'TRUE '
      IF (  LWNSG )      WRITE ( CHSUMM(22)(34:38) , '(A5)' ) 'TRUE '
      WRITE ( CHSUMM(23)(34:41) , '(F8.2)' ) (XMCUT(I), I=1,4)
      WRITE ( CHSUMM(24)(34:41) , '(F8.2)' ) XMSTP
*      WRITE ( CHSUMM(25)(34:41) , '(F8.2)' ) XRANG
      WRITE ( CHSUMM(26)(34:41) , '(F8.2)' ) XSEGR
      WRITE ( CHSUMM(27)(34:41) , '(F8.2)' ) XSTHR
      WRITE ( CHSUMM(28)(34:41) , '(F8.2)' ) XMERG
      WRITE ( CHSUMM(29)(35:61) , '(3I9)' ) ( XRAWH(I) , I = 1,3 )
      WRITE ( CHSUMM(30)(34:41) , '(I8)' ) INGRP
      WRITE ( CHSUMM(31)(34:41) , '(F8.2)' ) DIVTK
      
c      WRITE ( CHSUMM(32)(34:37) , '(I4)' ) DODIR
c      WRITE ( CHSUMM(33)(34:41) , '(I8)' ) ELREC
c      WRITE ( CHSUMM(34)(34:37) , '(I4)' ) INOPA      
c      WRITE ( CHSUMM(35)(34:37) , '(I4)' ) RECHO        
* and then print the summary out 

      IF ( status .EQ. 0 ) THEN
         WRITE ( 6 , '(A80)') ( CHHEAD ( ILINE ) , ILINE = 1 , 5 )
         WRITE ( 6 , '(A80)') ( CHSUMM ( ILINE ) , ILINE = 1 , 30 )
         WRITE ( 6 , '(A80)') ( CHFOOT ( ILINE ) , ILINE = 1 , 2 )
      ENDIF

* Finally, set the internal km3mc variables
 
      IF ( LVERB ) h_quiet       = 0 
      IF ( .NOT. LVERB ) h_quiet = 0
      IF ( LMUSI ) h_music       = 1 
      IF ( .NOT. LMUSI ) h_music = 0
      evt_type(1)                = CHTYP
c      h_seg_length_km3           = XMSTP
      h_shower_thresh            = XSTHR
      h_event_format             = IOFMT
      INTPOL                     = INPOL
      if (INTPOL .lt. 0) then
      	 INTPOL=0
	 write(*,*) 'using new interpolation method'
	 USENEW=1
      else
      	 USENEW=0
      endif
      io_event_file              = CHINP
      gen_nevents                = INEVT
c XM cut parameters are now for:
c muon direct distance
c muon scattered distance
c elec base distance (at 100 GeV)
c elec scaling distance (per factor 10 energy increase)
      h_rho_muon_dir_cut       = XMCUT(1)
      h_rho_muon_scat_cut             = XMCUT(2)
      h_rho_elec_cut_base = XMCUT(3)
      h_rho_elec_cut_del = XMCUT(4)
      
      min_seg_ratio              = XSEGR
      
      el_dir_nbins(1,1)          = IEFIL
      if ( el_dir_nbins(1,1) .gt. max_energy ) then
c there are too many energy bins and the max_energy parameter in file
c km3.inc needs to be changed and the code re-compiled
           status = 1
           write (*,*) 'FATAL ERROR: too many electron shower energies'
           write (*,*) 'change param max_energy in km3.inc & recompile'  
      endif
c copy the # of energy bins into the other arrays
      el_dir_nbins(2,1) = el_dir_nbins(1,1) ! set # energy bins
      el_sca_nbins(1,1) = el_dir_nbins(1,1) ! set # energy bins
      el_sca_nbins(2,1) = el_dir_nbins(1,1) ! set # energy bins

      io_photon_desc_file         = CHPHD
      io_photon_rz_file           = CHPHH
      io_geom_file                = CHGEO
      h_out_format                = IIFMT
      io_out_file                 = CHOUT

      IF ( LWNEV ) THEN 
        io_nt_evt_file = CHNEV
        h_event_ntuple = 1
      ELSE 
        h_event_ntuple = 0
      ENDIF

      IF ( LWNSG ) THEN 
        io_nt_seg_file = CHNSG
        h_segment_ntuple = 1
      ELSE 
        h_segment_ntuple = 0
      ENDIF

      ISEED(1)                    = IRAND(1)
      ISEED(2)                    = IRAND(2)
      ISEED(3)                    = IRAND(3)
      ISEED(4)                    = IRAND(4)
      IK40(1)                     = IPT40(1)
      IK40(2)                     = IPT40(2)
      PHDIR                       = LPDIR
      PHSCA                       = LPSCA
      JGAIN                       = IGAIN
      JEMPT                       = IEMPT
      TMERG                       = XMERG
      TRAWH(1)                    = XRAWH(1)
      TRAWH(2)                    = XRAWH(2)
      TRAWH(3)                    = XRAWH(3)
      TNGRP                       = INGRP

      gen_job_counter = int( gen_nevents / 100 )    
c for using the trick of averaging over 27, 9 or 3 nearby segments: the
c constants have been increased by a factor of 2. as of v4r4
      
      H_min_seg_ratio=min_seg_ratio*DIVTK
c The following is now done in read muon desc file      
c      h_rho_min_27 = h_seg_length_km3 * 54.0 * min_seg_ratio *DIVTK
c      h_rho_min_9  = h_seg_length_km3 * 18.0  * min_seg_ratio *DIVTK
c      h_rho_min_3  = h_seg_length_km3 * 6.0  * min_seg_ratio *DIVTK 
      
      if ((h_music .ne. 0) .and. (EVT_TYPE(1) .eq. 'EVT_MUON')) then
      	 CALL GETENV('Meloss',M_eloss_file)
	 CALL GETENV('Mddxsections',M_double_diff_file)
	 CALL GETENV('Mxsections',M_xsection_file)
      endif
      
      write(*,*) 'we have now: ',evt_type(1), h_music
* cwj: turns direct photons off if set to 0
      H_do_dir_ph = DODIR;
* Governs the use of the one-particle approx (on/off), and the
* ID which should be assigned to OPA showers
      H_OPA = INOPA
      IF (H_OPA .eq. 1) THEN
      	 write(*,*) 'using the one-particle approximation'
      ELSEIF (H_OPA .eq. 2) THEN
      	 write(*,*) 'using the many-particle approximation'
      ELSE
      	 write(*,*) 'OPA turned off'
      ENDIF
      H_OPA_ID = OPAID
* cwj: determines whether or not to record the energy-loss of the muon
      if (ELREC .lt. 0) then
      	 write(*,*) 'FFKEY ELREC must be 0 or greater - setting to 0.'
	 ELREC = 0
      endif
      if (ELREC .eq. 0) then
      	 write(*,*) 'Not recording muon energy loss.'
      else
      	 write(*,*) 'Recording energy loss every ',
     & ELREC, 'segments'
      endif
      ELOSS_NSEGS = ELREC
c      ELOSS_DZ = h_seg_length_km3*ELOSS_NSEGS
      
      H_REC_HIT_ORIGIN = RECHO

c assumed energy loss of the tau per metre (probably it should be far less than this!)      
      TAU_ELOSS=TAUDE
            
      RETURN
      END
