C*/
      SUBROUTINE WRITE_ANTARES_EVENT
************************************************************************
*                                                                      *
*     Name           :  WRITE_ANTARES_EVENT                            *
*     Called by      :                                                 *
*     Author         :  Sergio Navas Concha                            *
*     Date of coding :   8-Jan-1999                                    *
*     Last update    :                                                 *
*     Task           :                                                 *
*                                                                      *
************************************************************************
*
      include 'km3.inc'
      include 'km3-hits.inc'
      include 'io_f77.inc'
*
      REAL      TIME, R, CHARGE, XCHARGE, XTIME
      INTEGER   I, INEXT, IOM, ITRK, ITYP, ITPA, IERR, ISEG
      CHARACTER*255 CHLINE
      REAL      TTS, RANGAIN, NARS, RANTTS
      INTEGER   IFLAG2, ITP

C-- TEMP
C      LOGICAL NEW_R, NEW_E
C      INTEGER NRUN, NEV, IEV
C      CALL EVINFO(NEW_R,NEW_E,NRUN,NEV,IEV)
C-- END TEMP
*
      CLOSE(50)
      IFLAG2 = 0
*
* Write the event header
*
C--- Protect against extremely large events

      IF (NLINES.GT.MAXHIT.OR.NLINES.GT.MAXDAT) THEN
        WRITE(*,*) "WRITE_ANTARES_EVENT: Event too large - ",
     &             NLINES,' hits (max is ',MAXHIT, MAXDAT, ')'
        WRITE(CHLINE,'(I8)') -NLINES
        CALL EVTAGA('total_hits',CHLINE,IERR)
        REWIND(50)                ! go to the file starting point 
        RETURN
      ENDIF

      WRITE(CHLINE,'(I8)') NLINES
      CALL EVTAGA('total_hits',CHLINE,IERR)
*
* D. Bailey, 19/07/00
*   Add the simple ARS SPE simulation from Geasim. Firstly, build up
*   the "HITLIST" common whilst looping over the hits. Not

      NHIT = NLINES

      DO I = 1, NLINES
*
      	if (H_REC_HIT_ORIGIN .eq. 1) then
            READ (50, 111, ERR=10, END=20)
     &       INEXT, IOM, CHARGE, TIME, ITYP, ITPA, ITRK, ISEG
	else
	    READ (50, 110, ERR=10, END=20)
     &       INEXT, IOM, CHARGE, TIME, ITYP, ITPA, ITRK
        endif
	GOTO 30
c
   10   CONTINUE
        WRITE(*,*) 
     + '* WRITE_ANTARES_EVENT Error ... problems reading file fort.50'
        READ (50, 330, ERR=20, END=20) CHLINE
        GOTO 99
c
   20   CONTINUE
        WRITE(*,*) 
     + '* WRITE_ANTARES_EVENT Error : serious problem reading fort.50'
        GOTO 99
	
   30   CONTINUE
*     
* Apply gain randomisation and TTS if required
*
        XCHARGE = CHARGE  ! photoelectron amplitude before randomisation
        XTIME = TIME      ! unsmeared hit time
        IF (JGAIN.GE.1) THEN
  	  ITP = IDPMTYP( 1 ) ! Finds the PM-TYPE of this PM (phomul)
		! assume all OMs equal (patch to work with real LCM-IDs)
	  TTS = TTSTYP( ITP )  ! Finds the TTS (ns) of this PM (phomul)
          XCHARGE  = RANGAIN(CHARGE)

C--- Calls RANTTS from libgeasim for Gaussian (JGAIN=1) or +tail (JGAIN=2)
          XTIME = RANTTS(TTS/SQRT(CHARGE),JGAIN-1)
C-- TEMP
C          IF (NEV.EQ.20255) THEN 
C            PRINT*,XTIME
C          ENDIF
C-- END TEMP
          XTIME = XTIME + TIME

C-- TEMP
C          IF (NEV.EQ.20255) THEN 
C            PRINT*,TTS, SQRT(CHARGE), JGAIN, TIME, XTIME, XTIME-TIME
C          ENDIF
C 1219 66  2.  2089.5 3 1 59
C  1.29999995  1.41421354 1  2089.5 -2511016.75 -2513106.25
C-- END TEMP

c        ELSE
c          CHARGE = 0.
c          TIME = 0.
        ENDIF
*
*   For each hit, add an entry in the "HITLIST" common
  
        IHPM(I) = IOM
        RPE(I) = XCHARGE
        THIT(I) = XTIME
        IGEHIT(I) = ITYP
        ITRHIT(I) = ITPA
        IPEPUR(I) = CHARGE
        TPUR(I) = TIME
      	 
	if (H_REC_HIT_ORIGIN .eq. 1) then
	    WRITE(CHLINE,221) INEXT,
     &       IOM, XCHARGE, XTIME, ITYP, ITPA, int(CHARGE), TIME, ISEG
        else
	 WRITE(CHLINE,220)
     &       INEXT, IOM, XCHARGE, XTIME, ITYP, ITPA, int(CHARGE), TIME
      	endif

        CALL EVTAGA('hit',CHLINE,IERR)
        IF (IERR.NE.0 .AND. IFLAG2.EQ.0) THEN
          WRITE(6,'('' error FROM EVTAGA  '',I3,I10)') IERR,GEN_EVENT_ID
          IFLAG2 = 1
        ENDIF
   99   CONTINUE
      ENDDO
*
*   Now call the Geasim "ADDRAW" routine

      IF (TRAWH(1).GT.0) THEN
        CALL ADDRAW(TRAWH(1),TRAWH(2),TRAWH(3),IFLAG2)
        IF (IFLAG2.NE.0) THEN
          WRITE(6,'('' ADDRAW :event ''
     +   ,I5,'' error '',I5)') GEN_EVENT_ID,IFLAG2
        ENDIF
      ENDIF
      IFLAG2 = 0

      REWIND(50)                ! go to the file starting point 
*
c 110  FORMAT('hit:',1X,I7,1X,I5,1X,F6.1,1X,F10.2,3(1X,I6))
 110  FORMAT('hit:',1X,I7,1X,I7,1X,F6.1,1X,F11.2,3(1X,I6))
 111  FORMAT('hit:',1X,I7,1X,I7,1X,F6.1,1X,F11.2,4(1X,I6))
 220  FORMAT(2I7,1X,F10.2,1X,F10.2,1X,3I8,F10.2)
 221  FORMAT(2I7,1X,F10.2,1X,F10.2,1X,3I8,F10.2,1X,I6)
 330  FORMAT(A255)
      RETURN
*
      END
