
include ${ANTRS_RULES}/compiler.def
include ${ANTRS_RULES}/versions.def

package = io
version = ${IO_V}
IOLIB = 
SRC = src
BIN = ${ARCH}
INC = -Iinc
F77OPT = ${F77OP} -fPIC -o
C++OPT = ${C++OP} -fPIC -o

OBJS = ${BIN}/io_f77${IO_V}.o \
       ${BIN}/filopenin.o \
       ${BIN}/filopenou.o

all : info createdir fortran77 cplusplus

fortran77 : ${BIN}/lib${package}_f77${version}.a

cplusplus : ${BIN}/io_gcc${IO_V}.o

${BIN}/lib${package}_f77${version}.a : ${OBJS}
	ar -rcv $@ ${OBJS}   

${BIN}/io_f77${IO_V}.o : ${SRC}/io_f77.f
	${F77} ${F77OPT} $@ ${SRC}/io_f77.f ${INC} 

${BIN}/filopenin.o : ${SRC}/filopenin.F 
	${F77} ${CPPOPT} ${F77OPT} $@ ${SRC}/filopenin.F

${BIN}/filopenou.o : ${SRC}/filopenou.f 
	${F77} ${F77OPT} $@ ${SRC}/filopenou.f

${BIN}/io_gcc${IO_V}.o : ${SRC}/io_gcc.cc
	${C++} ${C++OPT} $@ ${SRC}/io_gcc.cc ${INC} 

createdir :
	@test -d "${BIN}" || (echo "Creating ${BIN}"; mkdir ${BIN})	

install :
	@test -f "${BIN}/lib${package}_f77${IO_V}.a" && \
	(echo "Now moving object files to $(ANTRS_LIB)"; \
	 mv ${BIN}/lib${package}_f77${IO_V}.a $(ANTRS_LIB)/.)
	@test -f "${BIN}/io_gcc${IO_V}.o" && \
	(echo "Now moving object files to $(ANTRS_LIB)"; \
	 mv ${BIN}/io_gcc${IO_V}.o $(ANTRS_LIB)/.)
clean :
	rm -f ${BIN}/*	

info : 
	@echo "Targets : fortran77 cplusplus install clean"   

