/*#############################################################
 *#                                                           #
 *#    Author: G.Carminati                                    #
 *#    First Release: Jan 2006                                #
 *#                                                           #
 *#############################################################
 */

#ifndef CONVERTING_UNITS_H
#define CONVERTING_UNITS_H

/* CLHEP include files (see http://wwwinfo.cern.ch/asd/lhc++/clhep ) */
#include "CLHEP/Units/PhysicalConstants.h"
using namespace CLHEP;

// 
//! Length [L]
//
inline double MeterToKm()   { return 1.e-3; }
inline double KmToMeter()   { return 1.e+3; }
inline double Km2ToMeter2() { return KmToMeter()*KmToMeter(); }

//
//! Angle
//
inline double RadToDeg() { return 180./pi; }
inline double DegToRad() { return pi/180.; }

//
//! Time [T]
//
inline double sTOdays() { return 1/86400.; }

//
//! Energy [E]
//
inline double GeVtoTeV() { return 1.e-3; }
inline double TeVtoGeV() { return 1.e+3; }

/*! \class ConvertingUnits
 *  \brief A class to convert units 
 *
 *  G.Carminati - First release: Jan 2006
 */


#endif /* CONVERTING_UNITS_H */
