/*#############################################################
 *#                                                           #
 *#    Author: G.Carminati                                    #
 *#    First Release: Mar 2007                                #
 *#                                                           #
 *#############################################################
 */

#ifndef DECODE_h
#define DECODE_h

#include<fstream>
#include<string>

class Decode
{
public:
  Decode(){};            //!< constructor
  virtual ~Decode(){};   //!< virtual destructor

  //! Decode command line
  int CommandLine(int argc, char** argv);

  //! Decode parameters from the input file
  int DecodeParameters();

  //! Handling error when read command line
  std::string ErrorCommandLine();

  //! Handling error when opening files
  std::string ErrorOpenFiles(int& nerror);

  //! Handling error
  std::string ErrorDecoder(int& nerror);
};

/*! \class Decode
 *  \brief A class to decode the input file 
 *
 *  G.Carminati - First release: Mar 2007
 */


#endif /*DECODE_h*/
