

########### basic directory structure #############


echo "Welcome to Clancy's simplified io and km3 installation. Before re-running this script, please change the Lyon cvs root username below to your own. Then remove the 'exit' after this statement, and comment this out."

#exit

echo "This script will set up this local directory as the ANTARES base directory, and install the io package, and download km3 source. You will need to ensure that cern libraries have been installed."

# directory in which to install ANTARES stuff
export BASEDIR=`pwd`

# to get packages (substitute your username please!)
export CVSROOT=cjames@ccage.in2p3.fr:/afs/in2p3.fr/throng/antares/src/CVS

# defines standard subdirectories
export ANTRS_LIB=${BASEDIR}/lib
export ANTRS_RULES=${BASEDIR}/rules
export ANTRS_IO=${BASEDIR}/io
export ANTRS_KM3=$BASEDIR/km3

#makes the lib and rules directory - you must checkout the io package and km3 yourself
mkdir -vp ${ANTRS_LIB}
mkdir -vp ${ANTRS_RULES}

export ARCH=Linux


# now moves new .def and Make files to their correct positions
echo "cp standard_compiler.def $ANTRS_RULES/compiler.def"
cp standard_compiler.def $ANTRS_RULES/compiler.def
echo "cp standard_versions.def $ANTRS_RULES/versions.def"
cp standard_versions.def $ANTRS_RULES/versions.def


echo "Please ensure you have access to the cern libraries, i.e. cernlib in the standard path. This is required by the km3 Makefile definition of CERNLIBS, which is given in standard_compiler.def as requiring cernlib and genlib"


########### getting modified io and km3 versions#############

# gets stuff from CCLyon (this uses all CVS, since the old km3 was also stored there
echo "cvs co -r v5r1 km3"
cvs co -r v5r1 km3
echo "cvs co -r v1r13 io"
cvs co -r v1r13 io

#echo "Moving new makefiles and version definitions to correct directories"

mv $ANTRS_KM3/Makefile $ANTRS_KM3/orig_Makefile
cp -n new_km3_makefile.make $ANTRS_KM3/Makefile

mv $ANTRS_KM3/versions.def $ANTRS_KM3/orig_versions.def
cp -n new_km3_versions.def $ANTRS_KM3/versions.def

mv $ANTRS_IO/Makefile $ANTRS_IO/orig_Makefile
cp -n new_io_makefile.make $ANTRS_IO/Makefile

mv $ANTRS_IO/versions.def $ANTRS_IO/orig_versions.def
cp -n new_io_versions.def $ANTRS_IO/versions.def


######### Now, go ahead and make stuff #######

#cd io
#make
# I cannot get this to keep going, because I can't make the cern libraries

#cd km3
#make clean
#make
